-- 比武战斗结算界面
checkRequire("Lua_FightingResultBaseWindow");
Lua_BiWuFightEndWindow = class("Lua_BiWuFightEndWindow", Lua_FightingResultBaseWindow)
function Lua_BiWuFightEndWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_BiWuFightEndWindow";
	
	self.winTitleAtlas = "ui_zhujiemian_z_tzcg"; -- 挑战成功
	self.tieTitleAtlas = "ui_zhujiemian_z_tzsb"; -- 挑战失败
	self.failTitleAtlas = "ui_zhujiemian_z_tzsb"; -- 挑战失败
end

function Lua_BiWuFightEndWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.rankLab = UICreate.createLabel(self.content, "", 0, 116, 100, 30, 30);
	self.rankLab.name = "rankLab";
	self.rankLab.pivot = UIWidget.Pivot.Center;
	self.rankLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.rankLab:setDepth(5);

	self.honorLab = UICreate.createLabel(self.content, "", 0, -150, 400, 30, 30);
	self.honorLab.name = "honorLab";
	self.honorLab.pivot = UIWidget.Pivot.Center;
	self.honorLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.honorLab:setDepth(5);

	self.copperLab = UICreate.createLabel(self.content, "", -28, 0, 100, 30, 30);
	self.copperLab.name = "copperLab";
	self.copperLab.pivot = UIWidget.Pivot.Right;
	self.copperLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.copperLab:setDepth(5);

	self.expLab = UICreate.createLabel(self.content, "", 21, 0, 100, 30, 30);
	self.expLab.name = "expLab";
	self.expLab.pivot = UIWidget.Pivot.Left;
	self.expLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.expLab:setDepth(3);
end

function Lua_BiWuFightEndWindow:showWin(param)
	self:superCall("showWin", param);

	local bWin = param.ret == 0 and 1 or -1;
	self:setShowInfo(bWin, param.auto_return_time);

	if param.after_rank < param.before_rank then -- 排名上升
		self.rankLab.text = LanUtil.formateStr(LanUtil.getValue(120938), tostring(param.after_rank));
	else
		self.rankLab.text = LanUtil.getValue(120937);
	end

	if param.glory_point > 0 then
		self.honorLab.text = LanUtil.formateStr(LanUtil.getValue(120939), Lua_CommonUtil.getNumberTrans(param.glory_point));
	else
		self.honorLab.text = "";
	end

	local num = param.money.copper + param.money.bind_copper;
	if num > 0 then
		self.copperLab.text = LanUtil.formateStr(LanUtil.getValue(120954), Lua_CommonUtil.getNumberTrans(num));
	else
		self.copperLab.text = "";
	end

	if param.exp ~= 0 then
		self.expLab.text = LanUtil.formateStr(LanUtil.getValue(120940), Lua_CommonUtil.getNumberTrans(param.exp));
	else
		self.expLab.text = "";
	end
end

function Lua_BiWuFightEndWindow:hide()
	Lua_ProxyManager.getProxy("Lua_GamePlayProxy"):sExitCurScene();
	Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_OPEN, {openIdx = 4});

	self:superCall("hide");
end

function Lua_BiWuFightEndWindow:dispose()
	if self.rankLab then
		self.rankLab:dispose();
		self.rankLab = nil;
	end
	if self.honorLab then
		self.honorLab:dispose();
		self.honorLab = nil;
	end
	if self.copperLab then
		self.copperLab:dispose();
		self.copperLab = nil;
	end
	if self.expLab then
		self.expLab:dispose();
		self.expLab = nil;
	end
	self:superCall("dispose");
end