Lua_BiwuRecordsWindow = class("Lua_BiwuRecordsWindow", Lua_ThirdSizeWindow)
function Lua_BiwuRecordsWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(120925), false);
	self.w = 916;
	self.h = 606;
    self.winOffsetY = -23;
    self.btnCloseOffsetY = 19;
	self.windowName = "Lua_BiwuRecordsWindow";
	self.isClickClose = false;
end

function Lua_BiwuRecordsWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.titleBg = UICreate.createImage(self.content, "/images/common/ui_common_btd_2.png", 0, 290, 0, 0);
    self.titleBg:setDepth(2);
    self.titleBg.name = "titleBg";
    --self.btnClose:setLocation(423, 325, 0);

    self.bg = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_widget_m1", 0, -23.5, 885, 572);
    self.bg:setDepth(0);
    self.bg.name = "bg";

    self.titleNameText = UICreate.createLabel(self.content, LanUtil.getValue(120925) , 0, 0, 180, 30, 26);
    self.titleNameText.pivot = UIWidget.Pivot.Center;
    self.titleNameText:setLocation(0, 302, 0);     
    self.titleNameText:setDepth(3);
    self.titleNameText.name = "titleNameText";

	self.recordsList = Lua_DragList.new(self.content, 1, Vector4(0, -27, 916, 560));
    self.recordsList:setLocation(2, 3, 0);
    self.recordsList:setListCell(Lua_BiwuRecordsItem, 110, 910, 1);

    self:addLuaEvent("rArenaRecordsInfo", self, self.onUpdateRecords);
end

function Lua_BiwuRecordsWindow:onUpdateRecords(records)
	local arr = Array();
	if records ~= nil then
	    for i = 1, #records do
	        arr:add(records[i]);
	    end
	end
    self.recordsList:setLuaArrayData(arr, false);
end

function Lua_BiwuRecordsWindow:dispose()
    if self.recordsList ~= nil then
    	self.recordsList:dispose()
    	self.recordsList = nil;
    end
    self:superCall("dispose");
end







Lua_BiwuRecordsItem = class("Lua_BiwuRecordsItem", Lua_ListCell);
function Lua_BiwuRecordsItem:ctor(p)
    self:superCall("ctor", p, "BiWuRecordsItem_skin");
end

function Lua_BiwuRecordsItem:buildShowItem()
    self:superCall("buildShowItem");

    self.headIconItem = Lua_HeadIconItem.new(self.content);
    self.headIconItem:setDepth(5);
    self.headIconItem:setScale(0.8, 0.8, 0.8);
    self.headIconItem:setLocation(-260, 3, 0);
end

function Lua_BiwuRecordsItem:setData(data)
    self.data = data;
    if self.data ~= nil then
        if self.data.ret == 1 then -- 成功
        	self.winImg:setEnable(true);
        	self.failImg:setEnable(false);
        else
        	self.winImg:setEnable(false);
        	self.failImg:setEnable(true);
        end

        local str = "";
        local myName = DataCenter.roleData.name;
        if myName == self.data.att_name then -- 自己是攻击者
        	if self.data.ret == 1 then -- 成功
        		str = LanUtil.formateStr(LanUtil.getValue(120921), self.data.def_name);
	        else
	        	str = LanUtil.formateStr(LanUtil.getValue(120922), self.data.def_name);
	        end
        elseif myName == self.data.def_name then -- 自己是防御者
        	if self.data.ret == 1 then -- 成功
        		str = LanUtil.formateStr(LanUtil.getValue(120923), self.data.att_name);
	        else
	        	str = LanUtil.formateStr(LanUtil.getValue(120924), self.data.att_name);
	        end
        end
        self.descTxt.text = str;

        str = "";
        local num = self.data.after_rank - self.data.before_rank;
        if num < 0 then -- 排名上升
        	str = LanUtil.formateStr(LanUtil.getValue(120916), tostring(self.data.after_rank));
        elseif num > 0 then -- 排名下降
        	str = LanUtil.formateStr(LanUtil.getValue(120918), tostring(self.data.after_rank));
        else 	-- 排名不变
        	str = LanUtil.getValue(120917);
        end
        self.rankDesc.text = str;

        str = "";
        num = tonumber(self.data.left_time);
        if num > 60 then
	        str = LanUtil.formateStr(LanUtil.getValue(120919), TimeTransform.getInstance():transTimeLeft(num));
	    else
	    	str = LanUtil.formateStr(LanUtil.getValue(120920), tostring(num));
	    end
	    self.timeDesc.text = str;

        if isHeadReplaceOpen() and self.data.role_head_name ~= nil and self.data.role_head_name ~= "" then
            if self.data.head_frame ~= nil and self.data.head_frame ~= 0 then
                self.headIconItem:setData(self.data.career, self.data.role_head_name, DataCenter.roleData:getHeadFrame(data.head_frame));
            else
                self.headIconItem:setData(self.data.career, self.data.role_head_name, nil);
            end
        else
            if self.data.head_frame ~= nil and self.data.head_frame ~= 0 then
                self.headIconItem:setData(self.data.career, self.data.profession, DataCenter.roleData:getHeadFrame(data.head_frame));
            else
                self.headIconItem:setData(self.data.career, self.data.profession, nil);
            end
        end
    end
end

function Lua_BiwuRecordsItem:onPlayerSoundClick(go)

end

function Lua_BiwuRecordsItem:dispose()
    self:superCall("dispose");

end