checkRequire("Lua_NumberInputItem");
Lua_CopyCombineWindow = class("Lua_CopyCombineWindow", Lua_Window);
function Lua_CopyCombineWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyCombineWindow";
	self.skinName = "CopyCombineWindow_skin";
	self.isClickClose = true;
end

function Lua_CopyCombineWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.numItem = Lua_NumberInputItem.new(self.content);
	self.numItem.owner = self;
	self.numItem.callBack = self.onNumChange;
	self.numItem:setDepth(3);
	self.numItem:setAddTen(false);
	self.numItem:setMinMaxValue(1, 999);
	self.numItem:setWindowOffset(305, -70);
	self.numItem:setLocation(24.5, 48);

	self.ruleSp:addClickFuntion(self, self.onRuleClick);
	self.addSp:addClickFuntion(self, self.onAddClick);
	self.subBtn:addClickFuntion(self, self.onSubClick);
	self.cancelBtn:addClickFuntion(self, self.hide);

	self:addLuaEvent("COPY_DATA_UPDATE", self, self.onCopyDataUpdate);
	sendMsg(10404105);
end

function Lua_CopyCombineWindow:showWin(param)
	self.copyVo = DataCenter.copyData:getCopyById(param.id);
	self.degree = param.degree;
end

function Lua_CopyCombineWindow:onCopyDataUpdate()
	if self.copyVo.leftTimes > self.copyVo.sumTimes then
		self.timeTxt.text = "[00E125]"..self.copyVo.leftTimes.."/"..self.copyVo.leftTimes.."[-]";
	else
		self.timeTxt.text = "[00E125]"..self.copyVo.leftTimes.."/"..self.copyVo.sumTimes.."[-]";
	end

	self.numItem:setNum(self.copyVo.leftTimes);
	self.numItem:setMinMaxValue(2, self.copyVo.leftTimes);
end

function Lua_CopyCombineWindow:onNumChange(val)
	self.combineTime = val;
	self.costNum = self.copyVo:getCombineCost(val, self.degree);
	self.costTxt.text = LanUtil.formateStr(LanUtil.getValue(121196), self.costNum.."");
end

function Lua_CopyCombineWindow:onRuleClick(go)
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(121195));
end

function Lua_CopyCombineWindow:onAddClick(go)
	local copyVo = self.copyVo;
	local times = copyVo.leftBuyTimes == nil and 0 or copyVo.leftBuyTimes;
	Lua_WindowUtil.openWin("Lua_BuyTimesWindow", WinParam.ACTION_OPEN, {
		owner = self,
		configSign = copyVo.vip_index,
		residueTimes = times,
		costList = copyVo:getBuyTimeCostList(),
		costType = copyVo:getBuyTimeCostType(),
		callback = self.onBuyTimes,
		useGold = 1
	});
end

function Lua_CopyCombineWindow:onBuyTimes(val)
	Lua_CopyUtil.buyCopyTime(self.copyVo.id, val)
end

function Lua_CopyCombineWindow:onSubClick(go)
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, self.costNum, true, true) == false then
		return;
	end
	self.setCombineTime = self.combineTime;
	self:hide();
end

function Lua_CopyCombineWindow:hide()
	Lua_MsgUtil.callFunc("COPY_COMBINE_TIME", {combineTime = self.setCombineTime});

	self:superCall("hide");
end