-- 鼓舞
Lua_CopyGuWuWindow = class("Lua_CopyGuWuWindow", Lua_Window);
function Lua_CopyGuWuWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyGuWuWindow";
	self.skinName = "CopyGuWuWindow_skin";
	self.isClickClose = true;
end

function Lua_CopyGuWuWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.combineNum = 1;
	if DataCenter.copyInfoData.combine_times < 2 then
		self.combineTxt:setEnable(false);
		self.combineNum = 1;
	else
		self.combineTxt:setEnable(true);
		self.combineTxt.text = LanUtil.formateStr(LanUtil.getValue(121198),tostring(DataCenter.copyInfoData.combine_times));
		self.combineNum = DataCenter.copyInfoData.combine_times;
	end

	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.QIANKUN_COPY):getDegreeConfig(1);	
	self.cLimitCount = copyVo.copper_inspire;
	self.gLimitCount = copyVo.inspire_amount -  copyVo.copper_inspire;
	self.buffAdd = copyVo.buffer.percent;

	self.cCostTxt.text = copyVo.copper_cost[3] * self.combineNum;
	self.cCostIcon:setLocation(-101 + self.cCostTxt.width - 66, 42, 0);
	self.gCostTxt.text = copyVo.gold_cost[2] * self.combineNum;
	self.gCostIcon:setLocation(139.6 + self.gCostTxt.width - 14, 42, 0);

	self:guWuInfoUpdate();
	
	self.cBox:addBoxChange(self, self.onCBoxClick);
	self.gBox:addBoxChange(self, self.onGBoxClick);
	self.cInspireBtn:addClickFuntion(self, self.onCInspireBtn);
	self.gInspireBtn:addClickFuntion(self, self.onGInspireBtn);

	self:addLuaEvent("COPY_GUWU_INFO_UPDATE",self,self.guWuInfoUpdate);
end

function Lua_CopyGuWuWindow:dispose()
	self:superCall("dispose");
end

function Lua_CopyGuWuWindow:guWuInfoUpdate()
	local data = DataCenter.copyInfoData;

	self.cTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(122251), data.copper_buy, self.cLimitCount);
	self.cAddTxt.text = LanUtil.formateStr(LanUtil.getValue(110308), data.copper_buy * self.buffAdd);
	self.cBox.seleted = data.check_state == 1 or data.check_state == 3;

	self.gTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(122251), data.gold_buy, self.gLimitCount);
	self.gAddTxt.text = LanUtil.formateStr(LanUtil.getValue(110308), data.gold_buy * self.buffAdd);
	self.gBox.seleted = data.check_state == 2 or data.check_state == 3;
end

function Lua_CopyGuWuWindow:onCBoxClick(val)
	self.cBox.seleted = val;
	Lua_ProxyManager.getProxy("Lua_CopyProxy"):sSetAutoInspire(val, self.gBox.seleted);
end

function Lua_CopyGuWuWindow:onGBoxClick(val)
	self.gBox.seleted = val;
	Lua_ProxyManager.getProxy("Lua_CopyProxy"):sSetAutoInspire(self.cBox.seleted, val);
end

function Lua_CopyGuWuWindow:onCInspireBtn(go)
	Lua_ProxyManager.getProxy("Lua_CopyProxy"):sInspire(0);
end

function Lua_CopyGuWuWindow:onGInspireBtn(go)
	Lua_ProxyManager.getProxy("Lua_CopyProxy"):sInspire(1);
end