-- 幻灵副本
Lua_CopyHuanLingWindow = class("Lua_CopyHuanLingWindow", Lua_Window);
function Lua_CopyHuanLingWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyHuanLingWindow";
	self.skinName = "CopyHuanLingWindow_skin";
end

function Lua_CopyHuanLingWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isCreate = false;
	-- 70 -- 90 -- 100
	self.posList = {{-503, 103}, {-395, 194}, {-274, 127}, {-153, 148},
	{-37, 170}, {57, 130}, {147, 80}, {229, 130}, {322, 170}, {460, 206}};

	self.bossArr = Array();
	self.bossArr:add(self.boss_1);
	self.bossArr:add(self.boss_2);
	self.bossArr:add(self.boss_3);
	self.bossArr:add(self.boss_4);
	self.bossArr:add(self.boss_5);
	self.bossArr:add(self.boss_6);
	self.bossArr:add(self.boss_7);
	self.bossArr:add(self.boss_8);
	self.bossArr:add(self.boss_9);
	self.bossArr:add(self.boss_10);

	self.redDot:setEnable(false);

	self.rewardItem1 = Lua_RewardItem.new(self.content);
	self.rewardItem1:setLocation(-262, -155.5, 0);
	self.rewardItem1:setDepth(5);

	self.rewardItem2 = Lua_RewardItem.new(self.content);
	self.rewardItem2:setLocation(304.5, -155.5, 0);
	self.rewardItem2:setDepth(5);

	self.subBtn:addClickFuntion(self, self.onEnterClick);
	self.saoBtn:addClickFuntion(self, self.onSaoDangClick);
	self.spectralBtn:addClickFuntion(self, self.onSpectralClick);
	self.helpSp:addClickFuntion(self, self.onHelpBtnClick);

	self:addLuaEvent("COPY_DATA_UPDATE", self, self.onCopyDataUpdate);
end

function Lua_CopyHuanLingWindow:showWin(param)
	self.data = DataCenter.copyData:getCopyById(Lua_CopyData.HUANLING_COPY);

	local index_id;
	if type(param) == "table" then
		index_id = param.id;
		if param.onSceneLoaded ~= nil and param.onSceneLoaded == true then
			self:addLuaEvent("SCENE_LOADED", self, self.onSceneLoaded); -- 场景切换完毕
		elseif param.onSceneLoaded == nil then
			self:onSceneLoaded();
		end
	elseif type(param) == "number" then
		index_id = param;
		self:onSceneLoaded();
	end

	-- 双倍副本活动开启后 显示UI
	local isOpenDouble = DataCenter.OpenDressCarnivalData:isOpenCopyDouble(tonumber(index_id))
	if DataCenter.OpenDressCarnivalData:isOpenCopyDoubleExp(tonumber(index_id)) == true or isOpenDouble then
		self.doubleExpObj:SetActive(true);
	else
		self.doubleExpObj:SetActive(false);
	end
end

function Lua_CopyHuanLingWindow:onSceneLoaded()
	Lua_CopyUtil.sendGetCopyInfoMsg(Lua_CopyData.HUANLING_COPY);
end

function Lua_CopyHuanLingWindow:onCopyDataUpdate()
	local copyVo = self.data;
	self.titleName.text = copyVo.name;
	if copyVo.degreeRecord == copyVo.degree_amount then
		self.degree = copyVo.degreeRecord;
	else
		self.degree = copyVo.degreeRecord + 1;
	end

	local index = copyVo:getDegreeIndex(self.degree); -- 当前层数所在索引
	local arr = copyVo:getAllMonster(self.degree); -- 当前层数所有怪物
	self:showNeedPower(copyVo.spectral_power, arr[index].open_fightng);
	
	self.arrow:setLocation(self.posList[index][1], self.posList[index][2], 0);
	self.levelLabel.text = LanUtil.formateStr(LanUtil.getValue(141800), arr[index].name, arr[index].monster_name);

	local len = arr:getSize();
	if index == len then
		local rArr_1 = Array();
		for i,v in ipairs(arr[len].reward) do
			rArr_1:add(v);
		end
		self.rewardItem1:setClickWin(true);
		self.rewardItem1:setRewardByRewardList(rArr_1);

		self.rewardItem2:setEnable(false);
	else
		local rArr_1 = Array();
		for i,v in ipairs(arr[index].reward) do
			rArr_1:add(v);
		end
		self.rewardItem1:setClickWin(true);
		self.rewardItem1:setRewardByRewardList(rArr_1);

		self.rewardItem2:setEnable(true);

		local rArr_2 = Array();
		for i,v in ipairs(arr[len].reward) do
			rArr_2:add(v);
		end
		self.rewardItem2:setClickWin(true);
		self.rewardItem2:setRewardByRewardList(rArr_2);
		self.killBossRewards.text = LanUtil.formateStr(LanUtil.getValue(141806), tostring(arr[len].monster_name));
	end

	-- 战力不足跳转按钮置灰
	self.subBtn:setBtnEnable(copyVo.spectral_power >= arr[index].open_fightng);
	-- 当前层数第一关，扫荡按钮置灰
	self.saoBtn:setBtnEnable(self.degree ~= 1);
	self.redDot:setEnable(self.degree > 1 and copyVo.leftTimes > 0);

	if self.isCreate == false then
		self:onCreateBossIcon();
		self.isCreate = true;
	end
end

function Lua_CopyHuanLingWindow:showNeedPower(spectral_power, open_fightng)
	local str = "";
	if spectral_power < open_fightng then
		str = "["..Lua_ColorDefine.RED_STR.."]"..spectral_power.."[-]";
	else
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..spectral_power.."[-]";
	end
	self.needPower.text = LanUtil.formateStr(LanUtil.getValue(141802), str, tostring(open_fightng));
end

function Lua_CopyHuanLingWindow:onCreateBossIcon()
	local arr = self.data:getAllMonster(self.degree);
	local len = self.bossArr:getSize();
	for i = 1, len do
		if i == 2 or i == 4 or i == 7 or i == 10 then
			local bossIcon = UICreate.createImage(self.content, "", 0, 0, 0, 0);
			local posX = self.bossArr[i].mainContent.transform.localPosition.x;
			local posY = self.bossArr[i].mainContent.transform.localPosition.y;
			bossIcon:setLocation(posX, posY, 0);
			bossIcon:setUVRect(Vector4(0.01, 0, 1, 1));
			bossIcon.pivot = UIWidget.Pivot.Center;
			bossIcon.name = i;
			bossIcon:setDepth(6);
			if i == len then
				bossIcon:SetDimensions(100, 100);
				self.bossName.text = arr[i].monster_name;
			else
				bossIcon:SetDimensions(80, 80);
			end

			bossIcon:setUrl("/images/head/eidolon/" .. arr[i].monster_icon .. ".png");
			bossIcon:addClickFuntion(self, self.onIconClick);
			bossIcon.clickScale = false;
		end
	end
end

function Lua_CopyHuanLingWindow:onIconClick(go)
	local num = tonumber(tostring(go.gameObject.name));
	local arr = self.data:getAllMonster(self.degree);
	Lua_WindowUtil.openWin("Lua_HuanLingDetailWindow", WinParam.ACTION_OPEN, {spectral_power = self.data.spectral_power, data = arr[num], pos = self.posList[num]});
end

function Lua_CopyHuanLingWindow:onEnterClick()
	if self.data.degreeRecord + 1 > self.data.degree_amount then
		OperateAlert.show(LanUtil.getValue(141807));
		return;
	end
	Lua_CopyUtil.enterCopy(self.data.id, 0);
end

function Lua_CopyHuanLingWindow:onSaoDangClick()
	if self:checkEnter() == false then
		return;
	end
	Lua_CopyUtil.saoDangCopy(self.data.id, self.data.degreeRecord);
end

function Lua_CopyHuanLingWindow:checkEnter()
	if self.data.leftTimes == nil or self.data.leftTimes <= 0 then
		OperateAlert.show(LanUtil.getValue(141804));
		return false;
	end
	return true;
end

function Lua_CopyHuanLingWindow:onSpectralClick()
	Lua_WindowUtil.openWin("Lua_CopyHuanLingWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_EidolonWindow", WinParam.ACTION_OPEN, 2);
end

function Lua_CopyHuanLingWindow:onHelpBtnClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(141803));
end

function Lua_CopyHuanLingWindow:dispose()
	if self.rewardItem1 ~= nil then
		self.rewardItem1:dispose();
		self.rewardItem1 = nil;
	end
	if self.rewardItem2 ~= nil then
		self.rewardItem2:dispose();
		self.rewardItem2 = nil;
	end
	self.isCreate = false;

	self:superCall("dispose");
end