-- 副本减速界面
checkRequire("Lua_NumberInputItem");
Lua_CopyJianSuWindow = class("Lua_CopyJianSuWindow", Lua_Window);
function Lua_CopyJianSuWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyJianSuWindow";
	self.skinName = "CopyJianSuWindow_skin";
	self.isClickClose = true;
end

function Lua_CopyJianSuWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.numArr = Array();

	self.countBg:addClickFuntion(self, self.onCountBgClick);
	self.slowBtn:addClickFuntion(self, self.onSlowClick);
	self.slowAutoBtn:addClickFuntion(self, self.onAutoSlowClick);
	self.subtractBtn:addClickFuntion(self, self.onAubtractClick);
	self.plusBtn:addClickFuntion(self, self.onPlusClick);

	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.SHENLIAN_COPY);
	local degreeConfig = copyVo:getDegreeConfig(1);
	self.slowAmount = degreeConfig.wave;
	self.copyInfoData = DataCenter.copyInfoData;
	if self.copyInfoData.combine_times ~= nil or self.copyInfoData.combine_times > 0 then
		local combine_times = tonumber(self.copyInfoData.combine_times);
		local bindGoldCost = tonumber(degreeConfig.bind_gold_cost);
		self.bindGoldCost = bindGoldCost * combine_times;
	end

	self._count = 1;
	if self.copyInfoData.slow_wave > 0 then 
		self._count = self.copyInfoData.slow_wave;
	else
		if self.copyInfoData.cur_wave > 0 then
			self._count = self.copyInfoData.cur_wave;
		end
	end

	self.desLabel_1.text = LanUtil.getValue(129000);
	self.desLabel_2.text = LanUtil.formateStr(LanUtil.getValue(129001), tostring(self.bindGoldCost));
	if self.copyInfoData.combine_times < 2 then
		self.combineTxt:setEnable(false);
	else
		self.combineTxt:setEnable(true);
		self.combineTxt.text = LanUtil.formateStr(LanUtil.getValue(121198), tostring(self.copyInfoData.combine_times));
	end

	self:addLuaEvent("COPY_INFO_UPDATE", self, self.updateData);
	self:updateData();
end

function Lua_CopyJianSuWindow:updateData()
	local data = DataCenter.copyInfoData;
	if data.nowTime ~= nil then
		self.nowTime = data.nowTime;
	end
	self.slow_tick = data.slow_tick;
	self.slow_wave = data.slow_wave;
	self.cur_wave = data.cur_wave;

	if self.slow_tick > 0 then
		Lua_CommonUtil.addTimer("onJianSuDown", 0.2, self, self.onJianSuDown);
	else
		Lua_CommonUtil.removeTimer(self,self.onJianSuDown);
	end

	self:updatePanelInfo();
end

function Lua_CopyJianSuWindow:updatePanelInfo()
	self.count.text = self._count;
	if self.slow_wave > 0 then
		self.slowAutoBtn.label = LanUtil.getValue(129003);
		DataCenter.copyInfoData.isAutoSlow = true;
		return;
	else
		if (DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD) < self.bindGoldCost 
			and DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < self.bindGoldCost) then
			DataCenter.copyInfoData.isAutoSlow = false;
		end
	end

	if DataCenter.copyInfoData.isSlow == false then
		self.slowBtn:setBtnEnable(true);
		self.slowBtn:addClickFuntion(self, self.onSlowClick);
		self.slowBtn.label = LanUtil.getValue(129009);
		self.slowAutoBtn.label = LanUtil.getValue(129002);
	else
		self.count.text = self.cur_wave;
		self.slowBtn:setBtnEnable(false);
		self.slowBtn:removeClickFuntion(self, self.onSlowClick);
		self.slowBtn.label = LanUtil.getValue(129008);
		self.slowAutoBtn.label = LanUtil.getValue(129002);
	end
end

function Lua_CopyJianSuWindow:onCountBgClick()
	if DataCenter.copyInfoData.isSlow == true or self.slow_wave > 0 then
		return;
	end
	Lua_WindowUtil.openWin("Lua_CountInputWindow", WinParam.ACTION_AUTO, {pox = 425, poy = 10, callBackOwner = self, callBack = self.onCountInputCallBack});
end

function Lua_CopyJianSuWindow:onSlowClick()
	if self.slow_wave > 0 then
		OperateAlert.show(LanUtil.getValue(129007));
		return;
	end

	if DataCenter.copyInfoData.isAutoSlow == true then
		OperateAlert.show(LanUtil.getValue(129010));
		return;
	end

	Lua_ProxyManager.getProxy("Lua_CopyProxy"):sSlow(0);
	-- 当前可消耗礼金或元宝足够，减速成功
	if (DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD) > self.bindGoldCost 
		or DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) > self.bindGoldCost) then
		OperateAlert.show(LanUtil.getValue(129011));
		DataCenter.copyInfoData.isSlow = true;
	end
end

function Lua_CopyJianSuWindow:onAutoSlowClick()
	if DataCenter.copyInfoData.isSlow == true then
		OperateAlert.show(LanUtil.getValue(129006));
		return;
	end

	if self.slow_wave > 0 then
		-- 取消
		Lua_ProxyManager.getProxy("Lua_CopyProxy"):sSlow(-1);
		-- 当设置的波数大于当前波数
		if self._count > self.cur_wave then
			self._count = self.cur_wave;
			DataCenter.copyInfoData.isAutoSlow = false;
		end
	else
		-- 自动减速
		Lua_ProxyManager.getProxy("Lua_CopyProxy"):sSlow(self._count);
		-- 当前可消耗礼金或元宝足够，减速成功
		if (DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD) > self.bindGoldCost
			or DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) > self.bindGoldCost) then
			if self._count > self.cur_wave then
				OperateAlert.show(LanUtil.getValue(129012));
			elseif self._count == self.cur_wave then
				OperateAlert.show(LanUtil.getValue(129012));
				OperateAlert.show(LanUtil.getValue(129011));
			end
			DataCenter.copyInfoData.isAutoSlow = true;
		end
	end
end

function Lua_CopyJianSuWindow:onAubtractClick()
	if DataCenter.copyInfoData.isSlow == true or self.slow_wave > 0  then
		return;
	end

	if self._count <= self.copyInfoData.cur_wave then
		self._count = self.copyInfoData.cur_wave;
	else
		self._count = self._count - 1;
	end
	self.count.text = self._count;
end

function Lua_CopyJianSuWindow:onPlusClick()
	if DataCenter.copyInfoData.isSlow == true or self.slow_wave > 0 then
		return;
	end

	if self._count >= self.slowAmount then
		self._count = self.slowAmount;
	else
		if self._count <= DataCenter.copyInfoData.cur_wave then
			self._count = DataCenter.copyInfoData.cur_wave;
		end
		self._count = self._count + 1;
	end
	self.count.text = self._count;
end

function Lua_CopyJianSuWindow:onJianSuDown()
	local lt = self.slow_tick - (getTime() - self.nowTime);
	if lt > 0 then
		if DataCenter.copyInfoData.isAutoSlow == false then
			DataCenter.copyInfoData.isSlow = true;
		end
	else
		DataCenter.copyInfoData.isSlow = false;
		DataCenter.copyInfoData.isAutoSlow = false;
		Lua_CommonUtil.removeTimer(self,self.onJianSuDown);
	end
	self:updatePanelInfo();
end

function Lua_CopyJianSuWindow:onCountInputCallBack(data)
	if data.state == 3 then
		self._count = data.num;
	elseif data.state == 1 then
		self.count.text = ""
		self.numArr:add(data.num);
		for i = 1, self.numArr:getSize() do
			self.count.text = self.count.text .. self.numArr[i]
		end
		self._count = tonumber(self.count.text)
	elseif data.state == 0 then
		self.numArr:clear();
		self._count = self.copyInfoData.cur_wave
	end

	if data.state == 2 then
		self.numArr:clear();
	end
	self:checkRange(self._count)
	self.count.text = self._count;
end

function Lua_CopyJianSuWindow:checkRange(num)
	if self._count >= self.slowAmount then
		self._count = self.slowAmount
	elseif self._count < self.copyInfoData.cur_wave then
		self._count = self.copyInfoData.cur_wave;
	else
		self._count = num;
	end
end

function Lua_CopyJianSuWindow:dispose()
	DataCenter.copyInfoData.isSlow = false;
	Lua_CommonUtil.removeTimer(self,self.onJianSuDown);

	self:superCall("dispose");
end