checkRequire("Lua_LeftInfoBaseWindow");
checkRequire("Lua_CopyNameItem");
checkRequire("Lua_CopyStarItem"); -- 副本星级
checkRequire("Lua_CopyTargetItem"); -- 副本目标
checkRequire("Lua_CopyTipsItem"); -- 通關提示
checkRequire("Lua_CopyTimeItem"); -- 剩余时间
checkRequire("Lua_CopyQianKunItem"); -- 经验副本信息
checkRequire("Lua_CopyLimitTimeItem"); -- 限时任务时间
checkRequire("Lua_CopyNpcItem"); -- NPC信息
checkRequire("Lua_CopyWaveItem"); -- 轮次信息
checkRequire("Lua_CopyDescItem"); -- 文本
checkRequire("Lua_CopyJuHunEventItem"); -- 聚魂-当前事件
checkRequire("Lua_CopyMonsterDetailItem"); -- 聚魂-当前进度
checkRequire("Lua_CopyYinYuanItem"); -- 姻缘副本信息
checkRequire("Lua_CopyShenLianItem"); -- 神炼副本信息
checkRequire("Lua_CopyBossInfoItem"); -- 生肖副本信息
checkRequire("Lua_CopyKillMonsterItem"); -- 天选圣地击杀目标
checkRequire("Lua_CountDownAnimation");
Lua_CopyLeftInfoWindow = class("Lua_CopyLeftInfoWindow", Lua_LeftInfoBaseWindow);
function Lua_CopyLeftInfoWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_CopyLeftInfoWindow";
	self.skinName = "CopyLeftInfoWindow_skin";

	self.itemDic = {};
	self.itemDic[1] = Lua_CopyStarItem;
	self.itemDic[2] = Lua_CopyTargetItem;
	self.itemDic[3] = Lua_CopyTipsItem;
	self.itemDic[4] = Lua_CopyTimeItem;
	self.itemDic[5] = Lua_CopyQianKunItem;
	self.itemDic[6] = Lua_CopyLimitTimeItem;
	self.itemDic[7] = Lua_CopyNpcItem;
	self.itemDic[8] = Lua_CopyWaveItem;
	self.itemDic[9] = Lua_CopyKillMonsterItem;
	self.itemDic[10] = Lua_CopyDescItem;
	self.itemDic[11] = Lua_CopyTipsItem;
	self.itemDic[12] = Lua_CopyJuHunEventItem;
	self.itemDic[13] = Lua_CopyMonsterDetailItem;
	self.itemDic[14] = Lua_CopyYinYuanItem;
	self.itemDic[15] = Lua_CopyShenLianItem;
	self.itemDic[16] = Lua_CopyBossInfoItem;

	self.itemList = Array();
end

function Lua_CopyLeftInfoWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.curCopyId = -1;

	self.bg.clickScale = false;
	self.bg:addClickFuntion(self, self.onBgClick);

	self.titleBg.clickScale = false;
	self.titleBg:addClickFuntion(self, self.onTitleBgClick);

	self:addLuaEvent("COPY_INFO_UPDATE", self, self.onCopyInfoUpdate);
	self:addLuaEvent("MENU_OUT_CLICK", self, self.onMenuOutClick);
	self:addLuaEvent(EventsDefine.HOOK_STATE_CHANGE, self, self.onCheckHookPos);

	self:addTimer("checkScene", 1, self, self.onCheckScene);

	Lua_WindowUtil.openWin("Lua_CopyXieLingWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyJueXingWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyLingWenWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyMoneyWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyQiankunWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_TeamWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_TeamCommiteWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyYinYuanWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyShenLianWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyJunHunWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyHuanLingWindow", WinParam.ACTION_CLOSE);

	Lua_MsgUtil.callFunc("SET_MAIN_MENU", 2);

	self:onCopyInfoUpdate();
end

function Lua_CopyLeftInfoWindow:onBgClick(go)
end

function Lua_CopyLeftInfoWindow:onTitleBgClick(go)
end

function Lua_CopyLeftInfoWindow:onCheckScene()
	local sceneId = DataCenter.roleData.sceneId;
	local sceneData = Lua_SceneConfigData.getSceneConfig(sceneId);
	local curOpenWin = sceneData.config.open_win;
	local isShowWin = false;
	if curOpenWin ~= nil then
		for i,v in ipairs(curOpenWin) do
			if v == "Lua_CopyLeftInfoWindow" then
				isShowWin = true;
				break;
			end
		end
	end
	if isShowWin == false then
		self:hide();
	end
end

function Lua_CopyLeftInfoWindow:onMenuOutClick(o)
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneCfg == nil then
		return;
	end

	if sceneCfg.isMirrorMap == true then
		return;
	end

	local tipData = {};
	tipData.des = LanUtil.getValue(121121);  
	tipData.owner = self;
	tipData.type = 1;
	tipData.subFun = self.onOutClick; -- 确定
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
end

function Lua_CopyLeftInfoWindow:onOutClick(val)
	sendMsg(10400902);
	DataCenter.hook:stop();
end

function Lua_CopyLeftInfoWindow:onCopyInfoUpdate(a)
	local msg = DataCenter.copyInfoData;
	local copyVo = DataCenter.copyData:getCopyById(msg.script_type);
	if copyVo == nil then
		return;
	end

	local index = 0;
	local showStarTime;
	local showTimeIndex;
	if msg.script_type ~= self.curCopyId then
		self.curCopyId = msg.script_type;
		if self.itemList ~= nil then
			self.itemList:dispose();
			self.itemList:clear();
		end
		
		local item;
		local showInfoTips = false;
		for i,v in ipairs(copyVo.show_items) do
			index = index + 1;
			if v == 1 then
				showStarTime = index;
			elseif v == 4 then
				showTimeIndex = index;
			elseif v == 11 then
				showInfoTips = true;
			end

			if v ~= 11 then
				item = self.itemDic[v].new(self.content);
				self.itemList:add(item);
			end
		end
	
		if showTimeIndex ~= nil then
			self.itemList[showTimeIndex]:showInfoBtn(showInfoTips);
		end
	end
	
	local len = self.itemList:getSize();
	for i = 1, len do
		self.itemList[i]:updateData(msg);
	end

	if self.isFirst ~= true then
		self.isFirst = true;
		local h = 0;
		for i = 1, len do
			self.itemList[i]:setLocation(0, h, 0);
			if showStarTime ~= nil and showStarTime == i then
				self.itemList[i]:setLocation(0, 0, 0);
				h = h + self.itemList[i].height;
			end

			if showTimeIndex ~= nil and showTimeIndex == i then
				if h < -196 then
					self.itemList[i]:setLocation(0, h, 0);
					self.bg:SetDimensions(self.bg.width, self.bg.height + -196 - h);
				else
					self.itemList[i]:setLocation(0, -196, 0);
				end
				h = h + self.itemList[i].height;
			end
			h = h - self.itemList[i].height;
		end
	end

	if msg.script_type == Lua_CopyData.JUEXING_COPY then -- 觉醒副本马上变身
		if DataCenter.roleData:isTransing() == false and getTime() - msg.copy_start_time > 0.02 then
			local skillVo = DataCenter.skillData:findTransSkill();
			if skillVo ~= nil and skillVo.isCool == 0 then
				MsgUtil.callFunc("USE_SKILL", {skillId = skillVo.skillId, targetId = 0, isAuto = true});
			end
		end
	end

	self.curDegree = msg.script_degree;
	self.total_wave = msg.total_wave;
	self.finish_wave = msg.finish_wave;
	self.cur_wave = msg.cur_wave;
	self.kill_monster = msg.kill_monster
	self.total_monster = msg.total_monster;

	if msg.ready_tick > 0 then
		self:showCountDown(msg.ready_tick);
		local t = {};
		t.state = 11;
		t.canMove = false;
		t.canFight = false;
		t.canRush = false;
		t.canJump = false;
		t.canChangeAction = false;
		t.canJoyMove = false;
		t.noMoveSpeed = false;
		t.lastTime = msg.ready_tick;
		t.isOn = true;
		LuaUtil.setPlayerState(t);
		DataCenter.hook:stop();
	elseif msg.extra_tick > 0 then
		if self.showEnd == nil then
			local outmsg = {};
			outmsg.left_time = msg.extra_tick;
			outmsg.type = 1;
			Lua_MsgUtil.callFunc("OUTSCENE_COUNTDOWN_TIME", outmsg);
			self.showEnd = 1;
		end
	else
		if self.countDownAni ~= nil then
			DataCenter.hook:start();
		end
		local t = {};
		t.state = 11;
		t.isOn = false;
		LuaUtil.setPlayerState(t);
		self:showCountDown(0);
	end

	self:onCheckHookPos();
	if copyVo ~= nil then
		self.titleTxt.text = copyVo:getDegreeName(msg.script_degree);
	end
end

function Lua_CopyLeftInfoWindow:onCheckHookPos(go)
	if self.curCopyId == nil or self.curDegree == nil or self.total_wave == nil then
		return;
	end

	local copyVo = DataCenter.copyData:getCopyById(self.curCopyId);
	if copyVo == nil then
		return;
	end

	if (self.curCopyId == Lua_CopyData.SHILIAN_COPY or self.curCopyId == Lua_CopyData.XIELING_COPY) and self.total_wave ~= 0 then
		local f_wave = self.finish_wave;
		f_wave = f_wave + 1;
		local v = copyVo:getWavePos(self.curCopyId, f_wave);
		if v ~= nil and v ~= 1 then
			DataCenter.hook:setDefaultPos(v.x, v.y, v.z);
		end
		if self.curCopyId == Lua_CopyData.SHILIAN_COPY then
			local clearWalls = copyVo:getWaveClearWalls(self.curDegree, f_wave);
			if clearWalls ~= nil and clearWalls ~= 1 then
				for i,v in ipairs(clearWalls) do
					MsgUtil.callFunc("ADD_CLEAR_WALL", v);
				end
			end
		end
	end
end

function Lua_CopyLeftInfoWindow:onCountEnd()
	DataCenter.hook:start();
	self:showCountDown(0);
end

function Lua_CopyLeftInfoWindow:showCountDown(val)
	if val > 0 then
		if self.countDownAni == nil then
			self.countDownAni = Lua_CountDownAnimation.new(self.content, self, self.onCountEnd);
			self.countDownAni:setLocation(MainWinDefine.V_width / 2 - self.offsetWidth, -self.offsetHeight + 70, 0);
			self.countDownAni:setDepth(10);
		end
		self.countDownAni:playCountDown(val, 1);
	else
		if self.countDownAni ~= nil then
			self.countDownAni:dispose();
			self.countDownAni = nil;
		end
	end
end

function Lua_CopyLeftInfoWindow:dispose()
	Lua_WindowUtil.openWin("Lua_CopyShenYouWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyGuWuWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_CopyJianSuWindow", WinParam.ACTION_CLOSE);
	
	self:superCall("dispose");
end