checkRequire("Lua_CopyLingWenCellItem");
Lua_CopyLingWenWindow = class("Lua_CopyLingWenWindow", Lua_Window);
function Lua_CopyLingWenWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyLingWenWindow";
	self.skinName = "CopyLingWenWindow_skin";
end

function Lua_CopyLingWenWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.infoTxt.text = LanUtil.getValue(121105);
	self.rewardTxt.text = LanUtil.getValue(121106);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 370, 452));
	self.dragList:setLocation(-258, 10, 0);
	self.dragList:setListCell(Lua_CopyLingWenCellItem, 150, 370, 1);
	-- self.dragList.offsetMax = 0;
	self.dragList.offsetMin = -26;

	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem:setLocation(160, -152, 0);
	self.rewardItem:setClickWin(true);
	self.rewardItem:setDepth(5);

	self.toolimg = Lua_ToolImage.new(self.content);
	self.toolimg:setDepth(6);
	self.toolimg:setLocation(160, -14, 0);

	self.subBtn:addClickFuntion(self, self.onSendClick);
	self.saoBtn:addClickFuntion(self, self.onGetRewardClick);
	self.saoBtn:setEnable(false);

	self:addLuaEvent("COPY_DATA_UPDATE", self, self.onCopyDataUpdate);
end

function Lua_CopyLingWenWindow:showWin(param)
	self.data = param;
	if type(self.data) == "number" then
	self.data = DataCenter.copyData:getCopyById(Lua_CopyData.LINGWEN_COPY);
		Lua_CopyUtil.sendGetCopyInfoMsg(Lua_CopyData.LINGWEN_COPY);
	else
		Lua_CopyUtil.sendGetCopyInfoMsg(self.data.id);
	end
	-- self:onCopyDataUpdate();
end

function Lua_CopyLingWenWindow:onCopyDataUpdate(o)
	local copyVo = self.data;
	local passLayer = copyVo.degreeRecord == nil and 0 or copyVo.degreeRecord;

	local openFloors = getConfig( { "rune", "groove_unlock_cond" });
	local len = #openFloors;
	local openSlotFloor = 9999999;
	for i = 1, len do
		if i == 1 and passLayer < openFloors[i] then
			openSlotFloor = openFloors[i];
			break;
		elseif i > 1 and passLayer >= openFloors[i - 1] and passLayer < openFloors[i] then
			openSlotFloor = openFloors[i];
			break;
		end
	end

	local newSlots = getConfig( { "rune", "type_unlock_cond" });
	local newSlotsArr = Array();
	for k, v in pairs(newSlots) do
		newSlotsArr:add( { floor = tonumber(k), newType = tonumber(v[1]) });
	end
	newSlotsArr:sort("floor", false);

	len = newSlotsArr:getSize();
	local newSlotsObj = nil;
	local newSlotFloor = 9999999;
	for i = 1, len do
		if i == 1 and passLayer < newSlotsArr[i].floor then
			newSlotsObj = newSlotsArr[i];
			newSlotFloor = newSlotsArr[i].floor;
			break;
		elseif i > 1 and passLayer >= newSlotsArr[i - 1].floor and passLayer < newSlotsArr[i].floor then
			newSlotsObj = newSlotsArr[i];
			newSlotFloor = newSlotsArr[i].floor;
			break;
		end
	end

	local minFloor = math.min(newSlotFloor, openSlotFloor);
	if minFloor == 9999999 then
		openSlotFloor = openFloors[#openFloors];
		newSlotFloor = newSlotsArr[len].floor;
		minFloor = math.max(newSlotFloor, openSlotFloor);
	end

	self.unlockTxt.text = LanUtil.formateStr(LanUtil.getValue(121124), tostring(minFloor));
	self.desTxt1:setEnable(minFloor == openSlotFloor);
	self.desTxt2:setEnable(minFloor == newSlotFloor);
	if minFloor == newSlotFloor then
		local showItem = getConfig( { "rune", "type_unlock_item", minFloor });
		if showItem ~= nil and showItem ~= 0 then
			self.toolimg.data = Lua_ToolVo.createToolVo(showItem, 1, 0);
			self.toolimg:setEnable(true);
		else
			self.toolimg:setEnable(false);
		end
	else
		self.toolimg:setEnable(false);
	end

	self.copyList = Array();
	local degree_amount = copyVo.degree_amount;
	for i = 1, degree_amount do
		local index = degree_amount - i + 1;
		local v = getConfig( { copyVo.another_config, 2000000 + 1000 * copyVo.script_type + index });
		v.index = index;
		v.dif = index;
		v.isPass = index <= passLayer;
		v.canChallenge = passLayer + 1 == index;
		if i == 1 then
			v.pos = 3;
		else
			v.pos = 2;
		end
		self.copyList:add(v);
	end

	self.copyList:add( { pos = 1 });
	self.dragList:setLuaArrayData(self.copyList, false);
	self.dragList:moveToIndex(degree_amount - passLayer - 2);
	if passLayer == 0 then
		self:showSlectedFloor(self.copyList[degree_amount - 1]);
	elseif passLayer == degree_amount then
		self:showSlectedFloor(self.copyList[1]);
	else
		self:showSlectedFloor(self.copyList[degree_amount - passLayer]);
	end

	if copyVo.dailyReward == true then
		self.saoBtn:setBtnEnable(true);
	else
		self.saoBtn:setBtnEnable(false);
	end
end

function Lua_CopyLingWenWindow:showSlectedFloor(vo)
	if vo == nil then
		return;
	end
	self.selectedData = vo;
	
	local arr = Array();
	for i, v in ipairs(vo.reward) do
		arr:add(v);
	end
	self.rewardItem:setRewardByRewardList(arr);
end

function Lua_CopyLingWenWindow:onSendClick(go)
	Lua_CopyUtil.enterCopy(self.data.id, 0);
end

function Lua_CopyLingWenWindow:onGetRewardClick(go)
	if self.data.dailyReward == true then
		local cmd = ProtoPublic_pb.Proto10404107();
		cmd.script_type = self.data.id;
		sendMsg(10404107, cmd);
	end
end