-- 副本结算界面
checkRequire("Lua_FightingResultBaseWindow");
checkRequire("Lua_CopyMoneyResultItem");
checkRequire("Lua_CopyResultFailItem");
checkRequire("Lua_CopyQiankunResultItem");
Lua_CopyResultWindow = class("Lua_CopyResultWindow", Lua_FightingResultBaseWindow);
function Lua_CopyResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyResultWindow";

	self.winTitleAtlas = "ui_zhujiemian_z_tzcg"; -- 挑战成功
	self.tieTitleAtlas = "ui_zhujiemian_z_tzsb"; -- 挑战失败
	self.failTitleAtlas = "ui_zhujiemian_z_tzsb"; -- 挑战失败
	self.bShowStar = true;
end

function Lua_CopyResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.hook:stop();
end

function Lua_CopyResultWindow:showWin(param)
	self:superCall("showWin", param);

	local copyVo = DataCenter.copyData:getCopyById(param.script_type);
	local endTime = copyVo:getEndTime(param.script_degree);
	if param.result == nil or param.result == 1 then
		if param.script_type == Lua_CopyData.QIANKUN_COPY then -- 经验副本
			self.resultItem = Lua_CopyQiankunResultItem.new(self.content);
		else
			self.resultItem = Lua_CopyMoneyResultItem.new(self.content);
		end
		self.resultItem:setDepth(6);
		self.resultItem:updateData(param);

		-- print("param.script_type", param.script_type);
		if param.script_type == Lua_CopyData.LINGWEN_COPY
			or param.script_type == Lua_CopyData.XIELING_COPY
			or param.script_type == Lua_CopyData.QIANKUN_COPY
			or param.script_type == Lua_CopyData.JUHUN_COPY
			or param.script_type == Lua_CopyData.JUEXING_COPY
			or param.script_type == Lua_CopyData.YINYUAN_COPY
			or param.script_type == Lua_CopyData.SHENLIAN_COPY
			or param.script_type == Lua_CopyData.JUNHUN_COPY
			or param.script_type == Lua_CopyData.HUANLING_COPY
			or param.script_type == Lua_CopyData.ZODIAC_COPY then
			self.resultItem:setLocation(0, 0, 0);
		elseif param.script_type ==  Lua_CopyData.MONEY_COPY then
			self.resultItem:setLocation(0, -118, 0);
		else
			self.resultItem:setLocation(0, -50, 0);
			self.resultItem.rewardItem:setLocation(0, 25, 0);
		end

		if param.script_type == Lua_CopyData.LINGWEN_COPY and param.result == 1 then
			self.backTimeLang = 121191;
		end

		local hideStar = copyVo.showResultStar == false or param.result == nil;
		local showNext = param.script_type == Lua_CopyData.LINGWEN_COPY;
		if hideStar then
			self:hideStar();
			self:setShowInfo(1, endTime, 0, showNext);
		else
			self:setShowInfo(1, endTime, param.star, showNext);
		end
		self:showUI(not hideStar);

		if param.script_type == Lua_CopyData.LINGWEN_COPY
		or param.script_type == Lua_CopyData.ZODIAC_COPY then
			self.tipsBg:setEnable(false);
		end

		self:updateFightingResultBackTime();
	else
		self.resultItem = Lua_CopyResultFailItem.new(self.content);
		self.resultItem:setDepth(6);
		self.resultItem:setLocation(0, 0, 0);
		self:setShowInfo(-1, endTime, 0, false);

		self:hideStar();
		self:showUI(false);
	end

	if param.result == 1 then
		if param.script_type == Lua_CopyData.YINYUAN_COPY then
			if param.is_finish_test == 1 then
				OperateAlert.show(LanUtil.getValue(121189));
				self.titleIcon:setAltas("fight_atlas", "ui_zhujiemian_z_xylx"); -- 心有灵犀
			else
				OperateAlert.show(LanUtil.getValue(121190));
				self.titleIcon:setAltas("fight_atlas", "ui_zhujiemian_z_zjzl"); -- 再接再厉
			end
		else
			self.titleIcon:setAltas("fight_atlas", "ui_zhujiemian_z_tzcg"); -- 挑战成功
		end
	end
end

function Lua_CopyResultWindow:onCountDownEnd()
	if self.showData.script_type == Lua_CopyData.LINGWEN_COPY then
		if self.showData.result == 1 then
			self:onNextBtnClick();
		else
			self:onBackBtnClick();
		end
	else
		self:onBackBtnClick();
	end
end

function Lua_CopyResultWindow:onBackBtnClick(go)
	sendMsg(10400902);
	if self.showData.script_type == Lua_CopyData.HUANLING_COPY then
		Lua_WindowUtil.openWin("Lua_CopyHuanLingWindow", WinParam.ACTION_OPEN, {id = 16, onSceneLoaded = true});
	end
	self:superCall("onBackBtnClick", go);
end

function Lua_CopyResultWindow:onNextBtnClick(go)
	sendMsg(10404106);
	self:hide();
end

function Lua_CopyResultWindow:dispose()
	if self.resultItem ~= nil then
		self.resultItem:dispose();
		self.resultItem = nil;
	end

	self:superCall("dispose");
end