-- 副本扫荡成功界面
Lua_CopySaoDangWindow = class("Lua_CopySaoDangWindow", Lua_Window)
function Lua_CopySaoDangWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopySaoDangWindow";
	self.skinName = "CopySaoDangWindow_skin";
	self.isClickClose = true;
end

function Lua_CopySaoDangWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_RewardDragItem.new(self.content, 600);
	self.rewardItem.pivot = 2;
	self.rewardItem:setDepth(5);
	self.rewardItem:setLocation(0, -42, 0);
	
	self.subBtn:addClickFuntion(self,self.onBtnCloseClick);
	self.oneBtn:addClickFuntion(self,self.onOneMoreClick);
end

function Lua_CopySaoDangWindow:onOneMoreClick(o)
	local copyVo = DataCenter.copyData:getCopyById(self.data.script_type);
	local cvo = copyVo:getSaoDangCost(self.data.script_degree);
	if cvo ~= nil and self.data.script_type ~= Lua_CopyData.JUHUN_COPY  then
		local tvo = Lua_ToolVo.createToolVo(cvo[1], 1, 0);
		local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cvo[1]);
		if itemNum < cvo[2] then
			local neednum = cvo[2] - itemNum;
			local str = LanUtil.formateStr(LanUtil.getValue(121194), copyVo.name, tostring(cvo[2]), 
			tvo.colorName, tostring(neednum * Lua_CommonUtil.getCommonConfig("script_clean_gold",1)), tvo.colorName);
			Lua_WindowUtil.openWin("Lua_ItemDirectBuyWindow", nil, {owner = self, callBack = self.onItemDirectOk, itemId = cvo[1], needNum = cvo[2], info = str});
			return;
		end
	end

	if self.data.script_type == Lua_CopyData.JUHUN_COPY then
		local infoData = DataCenter.copyInfoData;
		if infoData.script_type == Lua_CopyData.JUHUN_COPY then
			OperateAlert.show(LanUtil.getValue(121184));
			return;
		end
		Lua_WindowUtil.openWin("Lua_JuHunZhuanPanWindow",WinParam.ACTION_OPEN, {saoDang = 1});
	else
		Lua_CopyUtil.saoDangCopy(self.data.script_type, self.data.script_degree);
	end
	self:hide();
end

function Lua_CopySaoDangWindow:onItemDirectOk()
	Lua_CopyUtil.saoDangCopy(self.data.script_type, self.data.script_degree);
	self:hide();
end

function Lua_CopySaoDangWindow:showWin(param)
	self:superCall("showWin", param);
	self.data = param;
	self:updateData(param);
end

function Lua_CopySaoDangWindow:setShowStar(val)
	for i = 1, 3 do
		self["star"..i]:setEnable(val);
	end
end

function Lua_CopySaoDangWindow:updateData(msg)
	local copyVo = nil;
	if msg.script_type ~= nil then
		copyVo = DataCenter.copyData:getCopyById(msg.script_type);
	end
	self:setShowStar(copyVo.showResultStar);

	local cvo = copyVo:getSaoDangCost(msg.script_degree);
	if cvo ~= nil and self.data.script_type ~= Lua_CopyData.JUHUN_COPY then
		local tvo = Lua_ToolVo.createToolVo(cvo[1], 1, 0);
		local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cvo[1]);
		self.saoImg:setAltas(tvo.atlas, tvo.referenceId);
		if itemNum >= cvo[2] then
			self.saoTxt.text = LanUtil.formateStr(LanUtil.getValue(121193), "[00E125]"..itemNum.."[-]", tostring(cvo[2]));
		else
			self.saoTxt.text = LanUtil.formateStr(LanUtil.getValue(121193), "[FF1616]"..itemNum.."[-]", tostring(cvo[2]));
		end
	end
	self.saoImg:setEnable(cvo ~= nil and self.data.script_type ~= Lua_CopyData.JUHUN_COPY);
	self.saoTxt:setEnable(cvo ~= nil and self.data.script_type ~= Lua_CopyData.JUHUN_COPY);

	if self.data.script_type == Lua_CopyData.HUANLING_COPY then
		self.saoImg:setEnable(false);
		self.saoTxt:setEnable(false);
		self.oneBtn:setEnable(false);
		-- self.subBtn.mainContent.transform.localPosition = Vector3(0, -172, 0);
		LuaUtil.setObjPos(self.subBtn.mainContent, 0, -172, 0);
	end

	local arr = Array();
	if msg.items == nil then
		for i,v in ipairs(msg.reward) do
			if v.id ~= 0 then
				arr:add(v);
			end
		end
	else
		for i,v in ipairs(msg.items) do
			if v.id ~= 0 then
				arr:add(v);
			end
		end
	end

	if copyVo == nil or copyVo.moneys == nil then
		self.moneyTxt1:setEnable(false);
		self.moneyTxt2:setEnable(false);
	else
		self.moneyTxt1:setEnable(false);
		self.moneyTxt2:setEnable(false);
		local len = arr:getSize();
		local moneys = copyVo.moneys;
		local moneyNum = {};
		local i = 1;
		while true and len > 0 do
			if table.indexOf(moneys, arr[i].id) ~= -1 then
				if moneyNum[arr[i].id] == nil then
					moneyNum[arr[i].id] = 0;
				end
				moneyNum[arr[i].id] = moneyNum[arr[i].id] + arr[i].amount;
				arr:remove(i);
				i = i -1;
				len = len - 1;
			end
			i = i + 1;
			if i > len then
				break;
			end
		end

		if table.indexOf(moneys, Lua_MoneyData.EXP) ~= -1 then
			local expNum = tonumber(tostring(msg.exp));
			if expNum > 0 then
				moneyNum[Lua_MoneyData.EXP] = expNum;
			end
		end

		i = 1;
		for k,v in pairs(moneyNum) do
			if i > 2 then
				break;
			end
			local toolvo = Lua_ToolVo.createToolVo(k, 1, 0);
			self["moneyTxt"..i].text = LanUtil.formateStr(LanUtil.getValue(121145), toolvo.name, Lua_CommonUtil.getNumberTrans(v));
			self["moneyTxt"..i]:setEnable(true);
			i = i + 1;
		end

		if i == 2 then
			self.moneyTxt1:setLocation(0, 18, 0);
		end
	end
	
	local len = arr:getSize();
	local itemDic = {};
	local rsList = Array();
	for i=1,len do
		local iid = arr[i].id;
		local tvo = Lua_ToolVo.createToolVo(arr[i].id, 1, 0);
		tvo:fromServer(arr[i]);
		if tvo.overlap > 0 then
			local keyStr = iid..""..arr[i].bind;
			if itemDic[keyStr] == nil then
				itemDic[keyStr] = tvo;
			else
				itemDic[keyStr].count = itemDic[keyStr].count + tvo.count;
			end
		else
			rsList:add(tvo);
		end
	end
	
	for k,v in pairs(itemDic) do
		rsList:add(v);
	end
	self.rewardItem:setRewardByArray(rsList);
end