-- 神炼副本
Lua_CopyShenLianWindow = class("Lua_CopyShenLianWindow", Lua_Window);
function Lua_CopyShenLianWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyShenLianWindow";
	self.skinName = "CopyShenLianWindow_skin";
end

function Lua_CopyShenLianWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem:setLocation(304, -155, 0);
	self.rewardItem:setDepth(5);

	self.oneBtn.label = LanUtil.getValue(121155);
	self.oneBtn:addClickFuntion(self, self.onOneEnterClick);
	self.addSp:addClickFuntion(self, self.onAddClick);
	self.itemTxt:addUrlClickFuntion(self, self.onUrlClick);
	if self.subBtn ~= nil then
		self.subBtn:addClickFuntion(self, self.onEnterClick);
		self.subBtn:setEnable(false);
	end
	if self.saoBtn ~= nil then
		self.saoBtn:addClickFuntion(self,self.onTeamClick);
		self.saoBtn:setEnable(false);
	end

	self.combineBox:addBoxChange(self, self.onCombineBoxChange);

	self:addLuaEvent("COPY_DATA_UPDATE", self, self.onCopyDataUpdate);
	self:addLuaEvent("COPY_COMBINE_TIME", self, self.onCopyCombine);
	self:addLuaEvent("PACK_UPDATE", self, self.onCopyDataUpdate);
end

function Lua_CopyShenLianWindow:showWin(param)
	self.data = DataCenter.copyData:getCopyById(Lua_CopyData.SHENLIAN_COPY);
	Lua_CopyUtil.sendGetCopyInfoMsg(Lua_CopyData.SHENLIAN_COPY);
	
	self:onCopyDataUpdate();

	self.infoTxt.text = self.data.des;

	if self.data:getCanCombine(1) == true then
		self.combineBox:setEnable(true);
	else
		self.combineBox:setEnable(false);
	end
	self.combineBox.seleted = false;

	local index_id;
	if type(param) == "table" then
		index_id = param.id;
	elseif type(param) == "number" then
		index_id = param;
	end

	-- 双倍副本活动开启后 显示UI
	local isOpenDouble = DataCenter.OpenDressCarnivalData:isOpenCopyDouble(tonumber(index_id))
	if DataCenter.OpenDressCarnivalData:isOpenCopyDoubleExp(tonumber(index_id)) == true or isOpenDouble then
		self.doubleExpObj:SetActive(true);
	else
		self.doubleExpObj:SetActive(false);
	end
end

function Lua_CopyShenLianWindow:onCopyDataUpdate(o)
	local copyVo = self.data;
	self.titleName.text = copyVo.name;
	if copyVo.leftTimes == nil or copyVo.leftTimes <= 0 then
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121109), "0");
	else
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121109), tostring(copyVo.leftTimes));
	end
	self.addSp:setLocation(self.timeTxt.mainContent.transform.localPosition.x + self.timeTxt.width + 21, -271, 0);

	local difData = getConfig( { copyVo.another_config, 2000000 + 1000 * copyVo.script_type + 1 });
	local arr = Array();
	if difData ~= nil and difData.reward ~= nil then
		for i,v in ipairs(difData.reward) do
			arr:add(v);
		end
	end
	self.rewardItem:setClickWin(true);
	self.rewardItem:setRewardByRewardList(arr);
	-- self.doubleExpObj.transform.localPosition = Vector3(258 + (46 * self.rewardItem.itemList:getSize()), -155, 0);
	LuaUtil.setObjPos(self.doubleExpObj, 258 + (46 * self.rewardItem.itemList:getSize()), -155, 0);

	local cItem = copyVo.cost_item;
	local itemName = Lua_ToolVo.createToolVo(cItem,1,1).colorName;
	local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local itemNum = bagData:getItemNum(cItem);
	local costNum = copyVo.cost_item_num;
	if itemNum >= costNum then
		self.itemTxt.text = LanUtil.formateStr(LanUtil.getValue(121150), itemName, "[00E125]"..itemNum.."[-]", tostring(costNum));
	else
		self.itemTxt.text = LanUtil.formateStr(LanUtil.getValue(121150), itemName, "[ff3d3d]"..itemNum.."[-]", tostring(costNum));
	end

	-- local hasTime = copyVo.leftTimes > 0; -- 剩余次数
	local leftBuyTimes = copyVo.leftBuyTimes or 0; -- 可购买次数
	if leftBuyTimes <= 0 then
		self.isBuyTxt.text = LanUtil.getValue(120962); -- 已購買
	else
		self.isBuyTxt.text = LanUtil.getValue(120961); -- 可購買
	end
end

function Lua_CopyShenLianWindow:onCopyCombine(o)
	if o.combineTime == nil or o.combineTime < 2 then
		self.combineBox.seleted = false;
	else
		self.combineBox.seleted = true;
		self.combineTime = o.combineTime;
	end
end

function Lua_CopyShenLianWindow:onOneEnterClick(go)
	if self:checkEnter() == false then
		return;
	end
	Lua_CopyUtil.enterCopy(self.data.id, 1, self.combineTime);
end

function Lua_CopyShenLianWindow:checkEnter()
	local copyVo = self.data;
	if copyVo.leftTimes == nil or copyVo.leftTimes <= 0 then
		local maxVipLv = getConfig({"vip_const", "max_vip_lv", "value"});
		local t = copyVo.leftBuyTimes;
		if DataCenter.roleData.vipType == maxVipLv and (t == nil or t == 0) then
			return true;
		end
		OperateAlert.show(LanUtil.getValue(121158));
		self:onAddClick();
		return false;
	end
	return true;
end

function Lua_CopyShenLianWindow:onAddClick(o)
	local copyVo = self.data;
	local t = copyVo.leftBuyTimes == nil and 0 or copyVo.leftBuyTimes;
	Lua_WindowUtil.openWin("Lua_BuyTimesWindow", WinParam.ACTION_OPEN, {owner = self, configSign = copyVo.vip_index,
		residueTimes = t, costList = copyVo:getBuyTimeCostList(),costType = copyVo:getBuyTimeCostType(), 
		useGold = 1, callback = self.onBuyTimes});
end

function Lua_CopyShenLianWindow:onBuyTimes(val)
	Lua_CopyUtil.buyCopyTime(self.data.id, val)
end

function Lua_CopyShenLianWindow:onUrlClick(url)
	if url ~= nil then
		local copyVo = self.data;
		local cItem = copyVo.cost_item;
		local tvo = Lua_ToolVo.createToolVo(cItem,1,1);
		Lua_PackUtil.showItemInfo(tvo, false);
	end
end

function Lua_CopyShenLianWindow:onEnterClick(o)
	local teamData = DataCenter.teamData;
	if teamData.hasTeam == false then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {des = LanUtil.getValue(122242), owner = self, type = 1, subFun = self.onCreateTeam});
	else
		if teamData.amILeader == true then
			if teamData.teamerArr:getSize() == 1 then
				Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {des = LanUtil.getValue(122243), owner = self, type = 1, subFun = self.onOnlyOneEnter});
			else
				teamData:enterCopy(self.data.id, 1);
			end
		else
			OperateAlert.show(LanUtil.getValue(122241));
		end
	end
end

function Lua_CopyShenLianWindow:onCreateTeam(o)
	local teamData = DataCenter.teamData;
	teamData:setTeamTargetByCopy(self.data.id, 1, true);
	local cmd = ProtoPublic_pb.Proto10100302();
	cmd.team_type = 3;
	cmd.level_low = teamData.minLv;
	cmd.lelev_upper = teamData.maxLv;
	cmd.script_type = self.data.id;
	cmd.script_degree = 1;
	sendMsg(10100302, cmd);
end

function Lua_CopyShenLianWindow:onOnlyOneEnter(o)
	DataCenter.teamData:enterCopy(self.data.id, 1);
end

function Lua_CopyShenLianWindow:onTeamClick(o)
	if DataCenter.teamData.hasTeam == true and DataCenter.teamData.amILeader == false then
		OperateAlert.show(LanUtil.getValue(122248));
		return;
	end
	Lua_WindowUtil.openWin("Lua_TeamWindow", nil, {act = 1, script_type = self.data.id, script_degree = 1});
end

function Lua_CopyShenLianWindow:onCombineBoxChange(val)
	local v = self.data:getCombineLevel(1);
	if v > DataCenter.roleData.level then
		self.combineBox.seleted = false;
		self.combineTime = 0;
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121199), v..""));
		return;
	end

	if val == true then
		if self.data.leftTimes < 2 then
			self.combineBox.seleted = false;
			self.combineTime = 0;
			OperateAlert.show(LanUtil.getValue(121197));
		else
			Lua_WindowUtil.openWin("Lua_CopyCombineWindow", nil, {id = self.data.id, degree = 1});
		end
	else
		self.combineTime = 0;
	end
end

function Lua_CopyShenLianWindow:changeToTarget()
	local teamData = DataCenter.teamData;
	if teamData.hasTeam == true and teamData.amILeader == true then
		teamData:setTeamTargetByCopy(self.data.id,1);
		local cmd = ProtoPublic_pb.Proto10100311();
		cmd.team_type = 3;
		cmd.level_low = teamData.minLv;
		cmd.level_upper = teamData.maxLv;
		cmd.script_type = self.data.id;
		cmd.script_degree = 1;
		sendMsg(10100311, cmd);
	end
end

function Lua_CopyShenLianWindow:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.hangEffect ~= nil then
		self.hangEffect:dispose();
		self.hangEffect = nil;
	end

	self:superCall("dispose");
end