-- 姻缘副本，结算选择道具
Lua_CopyYinYuanSelecteWindow = class("Lua_CopyYinYuanSelecteWindow", Lua_Window);
function Lua_CopyYinYuanSelecteWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyYinYuanSelecteWindow";
	self.skinName = "CopyYinYuanSelecteWindow_skin";
	self.showClose = false;
end

function Lua_CopyYinYuanSelecteWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.infoTxt.text = LanUtil.getValue(121186);

	local img;
	local pos = {{-165, 6}, {0, 6}, {165, 6}};
	self.items = Array();
	for i,v in ipairs(pos) do
		img = Lua_ToolImage.new(self.content);
		img:setLocation(v[1], v[2], 1);
		img:setDepth(5);
		img:setCanClick(false);
		self.items:add(img);
	end

	self.btn1:addClickFuntion(self, self.onSelected1);
	self.btn2:addClickFuntion(self, self.onSelected2);
	self.btn3:addClickFuntion(self, self.onSelected3);

	self.startTime = getTime();
	self:addTimer("Lua_CopyYinYuanSelecteWindow", 0.5, self, self.onCountDown);
	self:onCountDown();
end

function Lua_CopyYinYuanSelecteWindow:showWin(param)
	self.showData = param;
	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.YINYUAN_COPY);
	local itemList = copyVo.config.item_group[param.index + 1];
	
	-- Lua 生成随机数需要用到两个函数：
	-- 1. math.randomseed(n)：接收一个整数 n 作为随机序列种子
	-- 2. math.random([n [, m]])： 有三种用法： a. 无参调用，产生(0,1)之间的浮点随机数；b. 只有参数 n，产生(1-n)之间的整数；有两个参数 n，m，产生 n-m 之间的随机整数
	-- 相同的随机种子，生成的随即序列一定是相同的。所以程序每次运行，赋予不同的种子很重要，很自然想到使用系统时间作为随机种子
	math.randomseed(tostring(getTime()):reverse());
	local s = math.floor(3 * math.random()) + 1;
	for i = 1, 3 do
		local curIndex = i - s;
		if curIndex < 1 then
			curIndex = curIndex + 3;
		end
		local tvo = Lua_ToolVo.createToolVo(itemList[curIndex], 1, 0);
		self.items[i].data = tvo;
	end
end

function Lua_CopyYinYuanSelecteWindow:onSelected1(o)
	self:setSelected(1);
end

function Lua_CopyYinYuanSelecteWindow:onSelected2(o)
	self:setSelected(2);
end

function Lua_CopyYinYuanSelecteWindow:onSelected3(o)
	self:setSelected(3);
end

function Lua_CopyYinYuanSelecteWindow:setSelected(val)
	if self.hasSelected == true then
		return;
	end
	local msg = ProtoPublic_pb.Proto10404117();
	msg.item_id = self.items[val].data.id;
	msg.script_type = Lua_CopyData.YINYUAN_COPY;
	sendMsg(10404117, msg);

	self.items[val]:showSelected(true);

	self.btn1:setBtnEnable(false);
	self.btn2:setBtnEnable(false);
	self.btn3:setBtnEnable(false);
	self.hasSelected = true;
end

function Lua_CopyYinYuanSelecteWindow:onCountDown()
	local pt = getTime() - self.startTime;
	local lt = 30 - pt;
	if lt > 0 then
		lt = math.floor(lt);
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121178), tostring(lt));
	else
		math.randomseed(tostring(getTime()):reverse());
		local s = math.floor(3 * math.random()) + 1;
		self:setSelected(s);
		self:hide();
	end
end