Lua_CopyYinYuanTipsWindow = class("Lua_CopyYinYuanTipsWindow", Lua_Window);
function Lua_CopyYinYuanTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyYinYuanTipsWindow";
	self.skinName = "CopyYinYuanTipsWindow_skin";
	self.curNum = 1;
	self.isClickClose = true;
end

function Lua_CopyYinYuanTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leftBtn:addClickFuntion(self, self.onLeftBtnClick);
	self.rightBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_CopyYinYuanTipsWindow:showWin(param)
	self:superCall("showWin", param);

	if param ~= nil then
		self.owner = self.showData.owner;
		self.configSign = self.showData.configSign;
		self.curCanBuyTimes = self.showData.residueTimes;
		self.eachCostNum = self.showData.eachCost;
		self.costList = self.showData.costList;
		self.costType = self.showData.costType;
		self.callback = self.showData.callback;
		self.useGold = self.showData.useGold;

		self:updateVipInfo();
		self:updateCostMoney();
		self:updateCostImg();
		self:updateInfotxt();
	else
		self:hide();
	end
end

function Lua_CopyYinYuanTipsWindow:onLeftBtnClick(o)
	if DataCenter.roleData.partnerId == nil or DataCenter.roleData.partnerId == 0 then
		OperateAlert.show(LanUtil.getValue(121175));
		return;
	end

	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.YINYUAN_COPY);
	if copyVo.left_partner_buy == nil or copyVo.left_partner_buy == 0 then
		OperateAlert.show(LanUtil.getValue(121185));
		return;
	end

	if self.lastClickTime ~= nil and getTime() - self.lastClickTime < 1 then
		return ;
	end
	self.lastClickTime = getTime();
	
	local msg = getProtoMsg("Proto10404115");
	msg.script_type = Lua_CopyData.YINYUAN_COPY;
	msg.count = 1;
	sendMsg(10404115,msg);
	self:hide();
end

function Lua_CopyYinYuanTipsWindow:updateInfotxt()
	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.YINYUAN_COPY);
	local myTime = 0;
	if copyVo.leftTimes ~= nil then
		myTime = copyVo.leftTimes;
	end

	local myBuyTime = 0;
	if copyVo.leftBuyTimes ~= nil then
		myBuyTime = copyVo.leftBuyTimes;
	end

	local myPartnerTime = 0;
	if copyVo.left_partner_buy ~= nil then
		myPartnerTime = copyVo.left_partner_buy;
	end
	self.timeInfo.text = LanUtil.formateStr(LanUtil.getValue(121177), tostring(myTime), tostring(myBuyTime), tostring(myPartnerTime));
end

function Lua_CopyYinYuanTipsWindow:onBuyBtnClick(go)
	if DataCenter.roleData.partnerId == nil or DataCenter.roleData.partnerId == 0 then
		OperateAlert.show(LanUtil.getValue(121175));
		return;
	end

	if self.curCanBuyTimes <= 0 then
		OperateAlert.show(LanUtil.getValue(120930));
		return;
	end

	local ct = self.costType;
	if self.useGold == 1 and self.costType == Lua_MoneyData.BIND_GOLD then
		ct = Lua_MoneyData.GOLD_AND_BINDGOLD;
	end

	if self.costMoneyNum ~= nil 
		and DataCenter.moneyData:isMoneyEnough(ct, self.costMoneyNum, true, true) == false then
		return;
	end

	if self.owner ~= nil and self.callback ~= nil then
		self.callback(self.owner, self.curNum);
	end
	self:hide();
end

function Lua_CopyYinYuanTipsWindow:updateCostImg()
	if self.costType ~= nil then
		self.moneySp:setAltas("icon_atlas_3", Lua_MoneyData.getIconSpByMoneyType(self.costType));
	end
end

function Lua_CopyYinYuanTipsWindow:updateCostMoney()
	local num = self.curCanBuyTimes;
	if num <= 0 then
		self.curNum = 1;
	else
		if self.curNum > num then
			self.curNum = num;
		elseif self.curNum <= 0 then
			self.curNum = 1;
		end
	end
	self:updateCost();
end

function Lua_CopyYinYuanTipsWindow:updateCost()
	local num = 0;
	if self.costList ~= nil then
		local len = self.costList:getSize();
		local startNum = self.maxBuyNum - self.curCanBuyTimes + 1;
		local endNum = startNum + self.curNum - 1;
		for i = startNum, endNum do
			if i > len then
				num = num + self.costList[len];
			else
				num = num + self.costList[i];
			end
		end
	elseif self.eachCostNum ~= nil then
		num = self.eachCostNum * self.curNum;
	end

	self.costMoneyNum = num;
	local str = "";
	local ct = self.costType;
	if self.useGold == 1 and self.costType == Lua_MoneyData.BIND_GOLD then
		ct = Lua_MoneyData.GOLD_AND_BINDGOLD;
	end

	if num <= DataCenter.moneyData:getMoney(ct) then
		str = "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(num).."[-]";
	else
		str = "["..Lua_ColorDefine.RED_STR.."]"..tostring(num).."[-]";
	end
	self.costTxt.text = LanUtil.formateStr(LanUtil.getValue(120928), str);
	self.moneySp:setLocation(self.costTxt.mainContent.transform.localPosition.x + self.costTxt.width + 25, -69, 0);
end

function Lua_CopyYinYuanTipsWindow:updateVipInfo()
	self.vipLv_left = Lua_NumberImage.new(self.content);
	self.vipLv_left.prefix = "ui_daily_vip_";
	self.vipLv_left:setDepth(5);
	self.vipLv_left:setLocation(-117.5, 98, 0);

	self.vipLv_right = Lua_NumberImage.new(self.content);
	self.vipLv_right.prefix = "ui_daily_vip_";
	self.vipLv_right:setDepth(5);
	self.vipLv_right:setLocation(162.5, 98, 0);

	local ownVipType = DataCenter.roleData.vipType;
	local curNum = getConfig({"vip_level", ownVipType, self.configSign});
	if curNum == nil then
		curNum = 0;
	else
		curNum = curNum[1];
	end
	self.maxBuyNum = curNum;
	local maxVipLv = getConfig({"vip_const", "max_vip_lv", "value"});

	local nextVip = -1;
	for i = ownVipType + 1,maxVipLv do
		local num = getConfig({"vip_level", i, self.configSign});
		if num == nil then
			num = 0;
		else
			num = num[1];
		end

		if num > curNum then
			nextVip = i;
			break;
		end
	end

	if nextVip == -1 then
		for i=1, ownVipType - 1 do
			local index = ownVipType - i;
			local num = getConfig({"vip_level", index, self.configSign});
			if num == nil then
				num = 0;
			else
				num = num[1];
			end

			if num < curNum then
				nextVip = index;
				break;
			end
		end
	end

	if nextVip == -1 then
		nextVip = maxVipLv;
	end

	if nextVip >= ownVipType then
		self.times_left.text = LanUtil.formateStr(LanUtil.getValue(120929), "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(curNum).."[-]");
		self.vipLv_left.num = ownVipType;

		local nextNum = getConfig({"vip_level", nextVip, self.configSign});
		if nextNum == nil then
			nextNum = 0;
		else
			nextNum = nextNum[1];
		end
		self.vipLv_right.num = nextVip;
		self.times_right.text = LanUtil.formateStr(LanUtil.getValue(120929), "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(nextNum).."[-]");
	else
		self.arrow:setEnable(false);
		self.vip_right:setEnable(false);
		self.vip_bg_right:setEnable(false);
		self.times_right:setEnable(false);
		self.vipLv_right:setEnable(false);
		local nextNum = getConfig({"vip_level", ownVipType, self.configSign});
		if nextNum == nil then
			nextNum = 0;
		else
			nextNum = nextNum[1];
		end

		local viewName = getConfig({"vip_level", ownVipType, "view_name"});
		if viewName == "+" then
			self.vipLv_left:setAddIcon(viewName);
		else
			self.vipLv_left.num = ownVipType;
		end
		self.times_left.text = LanUtil.formateStr(LanUtil.getValue(120929), "["..Lua_ColorDefine.GREEN_STR.."]"..tostring(nextNum).."[-]");
	end
end

function Lua_CopyYinYuanTipsWindow:dispose()
	if self.vipLv_left ~= nil then
		self.vipLv_left:dispose();
		self.vipLv_left = nil;
	end
	if self.vipLv_right ~= nil then
		self.vipLv_right:dispose();
		self.vipLv_right = nil;
	end
	self.owner = nil;
	self.callBack = nil;

	self:superCall("dispose");
end