-- 姻缘副本
Lua_CopyYinYuanWindow = class("Lua_CopyYinYuanWindow", Lua_Window);
function Lua_CopyYinYuanWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyYinYuanWindow";
	self.skinName = "CopyYinYuanWindow_skin";
end

function Lua_CopyYinYuanWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem:setLocation(304, -155, 0);
	self.rewardItem:setDepth(5);
	self.rewardItem:setClickWin(true);

	self.oneBtn:addClickFuntion(self, self.onEnterClick);
	self.subBtn:addClickFuntion(self, self.onInviteClick);
	self.addSp:addClickFuntion(self, self.onAddClick);

	self:addLuaEvent("COPY_DATA_UPDATE", self, self.onCopyDataUpdate);
end

function Lua_CopyYinYuanWindow:showWin(param)
	if type(param) == "table" then
		self.data = param;
	else
		self.data = DataCenter.copyData:getCopyById(Lua_CopyData.YINYUAN_COPY);
	end
	Lua_CopyUtil.sendGetCopyInfoMsg(Lua_CopyData.YINYUAN_COPY);
	self.infoTxt.text = self.data.des;
	self:onCopyDataUpdate();
end

function Lua_CopyYinYuanWindow:onCopyDataUpdate()
	local copyVo = self.data;
	local difData = getConfig({copyVo.another_config, 2000000 + 1000 * copyVo.script_type + 1});
	local arr = Array();
	if difData ~= nil and difData.reward ~= nil then
		arr:add(difData.reward[1]);
	end
	self.rewardItem:setRewardByRewardList(arr);

	local hasTime = false;
	if copyVo.leftTimes == nil or copyVo.leftTimes <= 0 then
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121109), "0");
	else
		hasTime = true;
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121109), tostring(copyVo.leftTimes));
	end

	-- local hasTime = data.leftTimes > 0; -- 剩余次数
	local leftBuyTimes = copyVo.leftBuyTimes or 0; -- 可购买次数
	if leftBuyTimes <= 0 then
		self.leftTxt.text = LanUtil.formateStr(LanUtil.getValue(121176), "0");
	else
		self.leftTxt.text = LanUtil.formateStr(LanUtil.getValue(121176), tostring(leftBuyTimes));
	end
end

function Lua_CopyYinYuanWindow:onEnterClick(o)
	if DataCenter.roleData.partnerId == nil or DataCenter.roleData.partnerId == 0 then
		OperateAlert.show(LanUtil.getValue(121175));
		return;
	end

	if DataCenter.teamData.hasTeam == false then
		OperateAlert.show(LanUtil.getValue(121187));
	else
		if DataCenter.teamData.amILeader == true then
			DataCenter.teamData:enterCopy(self.data.script_type, 1);
		else
			OperateAlert.show(LanUtil.getValue(122241));
		end
	end
end

function Lua_CopyYinYuanWindow:onInviteClick(o)
	if DataCenter.roleData.partnerId == nil or DataCenter.roleData.partnerId == 0 then
		OperateAlert.show(LanUtil.getValue(121175));
		return;
	end

	local teamData = DataCenter.teamData;
	if teamData.hasTeam == false then
		teamData:setTeamTargetByCopy(self.data.script_type, 1, false);
		teamData.minLv = 1;
		teamData.maxLv = 999;
		teamData:createTeam();
	end

	if teamData.hasTeam == true and teamData.amILeader == true and teamData.targetVo.script_type ~= self.data.script_type then
		local cmd = ProtoPublic_pb.Proto10100311();
		cmd.team_type = 3;
		cmd.level_low = teamData.minLv;
		cmd.level_upper = teamData.maxLv;
		cmd.script_type = self.data.script_type;
		cmd.script_degree = 1;
		sendMsg(10100311, cmd);
	end

	local msg = getProtoMsg("Proto10100307");
	msg.role_id = DataCenter.roleData.partnerId;
	msg.type = 1;
	sendMsg(10100307,msg);
end

function Lua_CopyYinYuanWindow:onAddClick(o)
	local copyVo = self.data;
	local t = copyVo.leftBuyTimes == nil and 0 or copyVo.leftBuyTimes;
	Lua_WindowUtil.openWin("Lua_CopyYinYuanTipsWindow", WinParam.ACTION_OPEN, {owner = self,
		configSign = copyVo.vip_index, residueTimes = t, costList = copyVo:getBuyTimeCostList(),
		costType = copyVo:getBuyTimeCostType(), useGold = 1, callback = self.onBuyTimes});
end

function Lua_CopyYinYuanWindow:onBuyTimes(val)
	Lua_CopyUtil.buyCopyTime(self.data.id, 1)
end

function Lua_CopyYinYuanWindow:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end

	self:superCall("dispose");
end