Lua_CopyZodiacRewardWindow = class("Lua_CopyZodiacRewardWindow", Lua_Window);
function Lua_CopyZodiacRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyZodiacRewardWindow";
	self.skinName = "CopyZodiacRewardWindow_skin";
end

function Lua_CopyZodiacRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1079, 479));
	self.rewardList:setListCell(Lua_CopyZodiacRewardItem, 112, 1079, 1);
	self.rewardList:setLocation(0, -55, 0);
end

function Lua_CopyZodiacRewardWindow:showWin(param)
	self:superCall("showWin", param);

	self.titleNameLab.text = self.showData.remark;
	self.needPowerLab.text = LanUtil.formateStr(LanUtil.getValue(143609), self.showData.powerName);
	self.rewardList:setLuaArrayData(self.showData.rewardShowArr);
end

function Lua_CopyZodiacRewardWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CopyZodiacRewardItem = class("Lua_CopyZodiacRewardItem", Lua_ListCell);
function Lua_CopyZodiacRewardItem:ctor(p)
    self:superCall("ctor", p, "CopyZodiacRewardItem_skin");
end

function Lua_CopyZodiacRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem:setMaxShow(10);
	self.rewardItem:setLayout(98, 82, 10);
	self.rewardItem:setDepth(self.depth + 10);
	self.rewardItem:setClickWin(true);
	self.rewardItem:setMouseEnble(true);
	self.rewardItem:setLocation(-15, 4, 0);
end

function Lua_CopyZodiacRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.levelLab.text = "Lv."..data.open_level;
	self.powerLab.text = data.power;
	self.rewardItem:setRewardByArray(data.rewards);
end

function Lua_CopyZodiacRewardItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end