Lua_CountDownWindow = class("Lua_CountDownWindow",Lua_Window)
function Lua_CountDownWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_CountDownWindow";
	self.showClose = false;
	self.showBg = false;
	self.isModel = false;
end
function Lua_CountDownWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.countDownTxt = UICreate.createLabel(self.content,"",0,0,250,30,24);
	self.countDownTxt.pivot = UIWidget.Pivot.Center;
	self.countDownTxt:setLocation(0,141,0);
end
function Lua_CountDownWindow:showWin(param)
	--param:
	--[[
	param ={};
	param.leftTime = 10;
	param.showText = "剩余时间：{1}";
	param.cbOwner =self;
	param.cbFun = self.onCountDownFinish;
	param.cbFunParam = "finish countdown";
	--]]
	self.data = param;
	Lua_CommonUtil.removeTimer(self,self.cdStep);
	if param~= nil then
		self.endTime = getTime() + param.leftTime;		
		self:addTimer("countDownWindow_cdStep",0.1,self,self.cdStep,nil,-1);
	end
end
function Lua_CountDownWindow:hide()
	print("Lua_CountDownWindow:hide");
	self:finishCountDown();
	self:superCall("hide");
end
function Lua_CountDownWindow:finishCountDown()
	Lua_CommonUtil.removeTimer(self,self.cdStep);
	if self.data.cbOwner ~= nil and self.data.cbFun  ~= nil then		
		if self.data.cbFunParam ~= nil then
			self.data.cbFun(self.data.cbOwner,self.data.cbFunParam);
		else
			self.data.cbFun(self.data.cbOwner);
		end
	end
end
function Lua_CountDownWindow:cdStep()
	if self.endTime ~= nil then
		local leftTime = math.floor(self.endTime - getTime());
		if leftTime >0 then
			self.countDownTxt.text = LanUtil.formateStr(self.data.showText,tostring(leftTime));
		else
			self:hide();
		end
	end
end