-- 聚魂转盘
checkRequire("Lua_RotActionItem");
checkRequire("Lua_JunHunZhuanPanItem");
Lua_JuHunZhuanPanWindow = class("Lua_JuHunZhuanPanWindow", Lua_Window);
function Lua_JuHunZhuanPanWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JuHunZhuanPanWindow";
	self.skinName = "JuHunZhuanPanWindow_skin";
end

function Lua_JuHunZhuanPanWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isSaoDang = false;
	self.insideEnd = true;
	self.outsideEnd = true

	local item;
	self.wheelList = Array();
	for i = 1, 5 do
		item = Lua_JunHunZhuanPanItem.new(self.content);
		item:setLocation(322, 79 - 42 * (i - 1), 0);
		item:setIndex(i);
		self.wheelList:add(item);
	end

	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem.pivot = 2;
	self.rewardItem:setLocation(-436, -165, 0);
	self.rewardItem:setDepth(5);

	self.insideRot = Lua_RotActionItem.new(self.insideCircleSp);
	self.outsideRot = Lua_RotActionItem.new(self.outsideCircleSp);

	self.freeBtn.clickScale = false;
	self.zhuanBtn.clickScale = false;
	self.refreshBtn.clickScale = false;
	self.freeBtn:addClickFuntion(self, self.onDoCircle); -- 转盘
	self.zhuanBtn:addClickFuntion(self, self.onDoCircle); -- 转盘
	self.saveBtn:addClickFuntion(self, self.onSaveResult); -- 保存结果
	self.refreshBtn:addClickFuntion(self, self.onShowMonster); -- 开始刷怪

	self:addLuaEvent("JUHUN_INFO_UPDATE", self, self.onCopyInfoUpdate);
	self:addLuaEvent("JUNHUN_RESULT", self, self.onZhuanPanResult);
	self:addLuaEvent("COPY_DATA_UPDATE", self, self.updateCopyTIme);
	self:addTimer("Lua_JuHunZhuanPanWindow", 0.8, self, self.onEnterFrame);
	self:onCopyInfoUpdate();
end

function Lua_JuHunZhuanPanWindow:onBtnCloseClick(o)
	if self.isSaoDanging == true then
		OperateAlert.show(LanUtil.getValue(121183));
		return;
	end
	self:hide();
end

function Lua_JuHunZhuanPanWindow:dispose(o)
	if self.isSaoDanging == true then
		sendMsg(10404114);
		Lua_WindowUtil.openWin("Lua_CopySaoDangWindow",WinParam.ACTION_OPEN, self.saoDangData);
	end
	self:superCall("dispose");
end

function Lua_JuHunZhuanPanWindow:showWin(param)
	if param.saoDang == nil then
		return;
	end

	self.saoDangData = param.data;
	if self.saoDangData == nil then
		self.saoDangData = {};
	end

	self.isSaoDang = true;
	self.curIndex = 0;
	self:updateSaoDangData();
	if self.saoDangData.wheel_record ~= nil then
		self.isSaoDanging = true;
		self:onDoCircle();
	end
end

function Lua_JuHunZhuanPanWindow:updateCopyTIme()
	if self.isSaoDang ~= true then
		return;
	end
	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.JUHUN_COPY);
	self.freeTxt.text = LanUtil.formateStr(LanUtil.getValue(121173), tostring(copyVo.leftTimes));
end

function Lua_JuHunZhuanPanWindow:updateSaoDangData()
	if self.isSaoDang ~= true then
		return;
	end
	self.freebg:setEnable(true);
	self.freeTxt:setEnable(true);
	self.freeobj:SetActive(true);
	self.moneyobj:SetActive(false);

	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.JUHUN_COPY);
	self.freeTxt.text = LanUtil.formateStr(LanUtil.getValue(121173), tostring(copyVo.leftTimes));

	for i = 1, 5 do
		if self.saoDangData.wheel_record == nil or self.saoDangData.wheel_record[i] == nil or i > self.curIndex then
			self.wheelList[i]:setData(0, 0);
		else
			self.wheelList[i]:setData(self.saoDangData.wheel_record[i].obj_id, self.saoDangData.wheel_record[i].obj_value);
		end
	end

	if self.curIndex < 5 then
		self.freeBtnTxt.text = LanUtil.getValue(121182);
	else
		self.freeBtnTxt.text = LanUtil.getValue(121181);
	end

	local curData = getConfig( { copyVo.another_config, 2000000 + 1000 * Lua_CopyData.JUHUN_COPY + 1 });
	local arr = Array();
	for i,v in ipairs(curData.reward) do
		arr:add(v);
	end
	self.rewardItem:setClickWin(true);
	self.rewardItem:setRewardByRewardList(arr);

	local cvo = copyVo:getSaoDangCost(1);
	if cvo ~= nil then
		local tvo = Lua_ToolVo.createToolVo(cvo[1], 1, 0);
		local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cvo[1]);
		self.saoImg:setAltas(tvo.atlas, tvo.referenceId);
		if itemNum >= cvo[2] then
			self.saoTxt.text = LanUtil.formateStr(LanUtil.getValue(121193), "[00E125]"..itemNum.."[-]", tostring(cvo[2]));
		else
			self.saoTxt.text = LanUtil.formateStr(LanUtil.getValue(121193), "[FF1616]"..itemNum.."[-]", tostring(cvo[2]));
		end
	end
	self.saoTxt:setEnable(cvo ~= nil);
	self.saoImg:setEnable(cvo ~= nil);
end

function Lua_JuHunZhuanPanWindow:onCopyInfoUpdate(o)
	if self.isSaoDang == true then
		self:updateSaoDangData();
		return;
	end
	self.saoTxt:setEnable(false);
	self.saoImg:setEnable(false);

	local copyInfoData = DataCenter.copyInfoData;
	if copyInfoData.script_type == 0 or copyInfoData.script_type == 0 then
		return;
	end

	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.JUHUN_COPY);
	if copyInfoData.wheel_record == nil or #copyInfoData.wheel_record < 5 then
		if self.isSaoDang == false then
			if copyInfoData.pause_tick == 0 or copyInfoData.lastJuHunTime == -1 then
				self.freebg:setEnable(false);
				self.freeTxt:setEnable(false);
			else
				self.freebg:setEnable(true);
				self.freeTxt:setEnable(true);
			end
			self.freeobj:SetActive(false);
			self.moneyobj:SetActive(true);

			self.zhuanTxt:setGray(false);
			self.zhuanBtn:setGray(false);
			self.saveTxt:setGray(false);
			self.saveBtn:setGray(false);
			self.zhuanGray = false;
			self.saveGray = false;
		else
			self.freebg:setEnable(true);
			self.freeTxt:setEnable(true);
			self.freeobj:SetActive(true);
			self.moneyobj:SetActive(false);
		end
	else
		self.freebg:setEnable(false);
		self.freeTxt:setEnable(false);
		self.freeobj:SetActive(false);
		self.moneyobj:SetActive(true);

		self.zhuanTxt:setGray(true);
		self.zhuanBtn:setGray(true);
		self.saveTxt:setGray(true);
		self.saveBtn:setGray(true);
		self.zhuanGray = true;
		self.saveGray = true;
	end

	local curData = getConfig( { copyVo.another_config, 2000000 + 1000 * Lua_CopyData.JUHUN_COPY + 1 });
	local arr = Array();
	for i,v in ipairs(curData.reward) do
		arr:add(v);
	end
	self.rewardItem:setClickWin(true);
	self.rewardItem:setRewardByRewardList(arr);

	if self.insideEnd == true 
		and self.outsideEnd == true
		and copyInfoData.cur_wheel ~= nil
		and copyInfoData.cur_wheel.obj_id ~= 0
		and copyInfoData.cur_wheel.obj_value ~= 0 then
		self.insideRot:setRot((copyInfoData.cur_wheel.obj_id - 1) * 45);
		self.outsideRot:setRot((copyInfoData.cur_wheel.obj_value - 1) * 30);
	end

	self.needMoney = 0;
	if copyInfoData.free_times == 0 then
		local len = #curData.wheel_cost;
		for i=1,len do
			local c = curData.wheel_cost[i];
			if copyInfoData.used_times <= c[1] then
				self.needMoney = c[2];
				break;
			end
		end

		if self.needMoney == 0 then
			self.needMoney = curData.wheel_cost[len][2];
		end
	end

	if self.needMoney == 0 then
		self.zhuanTxt.fontSize = 28;
		self.zhuanTxt.text = LanUtil.getValue(121163);
		self.txt6:setEnable(false);
	else
		self.zhuanTxt.fontSize = 22;
		self.zhuanTxt.text = LanUtil.formateStr(LanUtil.getValue(121159), tostring(self.needMoney));
		self.txt6:setEnable(true);
	end
	
	for i = 1, 5 do
		if copyInfoData.wheel_record == nil or copyInfoData.wheel_record[i] == nil then
			self.wheelList[i]:setData(0, 0);
		else
			self.wheelList[i]:setData(copyInfoData.wheel_record[i].obj_id, copyInfoData.wheel_record[i].obj_value);
		end
	end
	self:updateBtnState();
end

function Lua_JuHunZhuanPanWindow:showRewardItem()
	local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.JUHUN_COPY);
	local curData = getConfig({ copyVo.another_config, 2000000 + 1000 * Lua_CopyData.JUHUN_COPY + 1 });
	local arr = Array();
	for i,v in ipairs(curData.reward) do
		arr:add(v);
	end
	self.rewardItem:setClickWin(true);
	self.rewardItem:setRewardByRewardList(arr);
end

function Lua_JuHunZhuanPanWindow:onEnterFrame()
	local copyInfoData = DataCenter.copyInfoData;
	if self.isSaoDang == true then
		if self.doNext == true then
			self:onDoCircle();
			self.doNext = false;
		end
		return;
	end
	
	if copyInfoData.pause_tick == 0 or copyInfoData.lastJuHunTime == -1 then
		self.freebg:setEnable(false);
		self.freeTxt:setEnable(false);
		return;
	end
	self.freebg:setEnable(true);
	self.freeTxt:setEnable(true);

	local pt = getTime() - copyInfoData.lastJuHunTime;
	local lt = copyInfoData.pause_tick - pt;
	if lt < 0 then
		lt = 0;
	end

	lt = math.floor(lt);
	self.freeTxt.text = LanUtil.formateStr(LanUtil.getValue(121170), tostring(lt));
	if pt < 1 then
		return;
	end

	if lt == 0 then
		if copyInfoData.free_times <= 0 then -- 保存
			self:onSaveResult();
			self:onShowMonster(1);
		else
			if self.refreshGray == false then
				self:onShowMonster();
				-- print("onShowMonster:");
			else
				self:onDoCircle();
			end
		end
	end
end

function Lua_JuHunZhuanPanWindow:onDoCircle(o)
	if self.zhuanGray == true then
		return;
	end

	local copyInfoData = DataCenter.copyInfoData;
	if copyInfoData.wheel_record ~= nil and #copyInfoData.wheel_record >= 5 then 
		self:onShowMonster();
		return;
	end

	if self.lastClickTime ~= nil and getTime() - self.lastClickTime < 0.5 then
		return;
	end

	if self.insideEnd == false or self.outsideEnd == false then
		OperateAlert.show(LanUtil.getValue(121164));
		return;
	end

	if self.isSaoDang == true then
		if self.isSaoDanging == true then
			self:onZhuanPanResult();
		else
			if self.saTime == nil or getTime() - self.saTime > 0.5 then
				self.saTime = getTime();
				local copyVo = DataCenter.copyData:getCopyById(Lua_CopyData.JUHUN_COPY);
				local cvo = copyVo:getSaoDangCost(1);
				if cvo ~= nil then
					local tvo = Lua_ToolVo.createToolVo(cvo[1], 1, 0);
					local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cvo[1]);
					if itemNum < cvo[2] then
						local neednum = cvo[2] - itemNum;
						local str = LanUtil.formateStr(LanUtil.getValue(121194), copyVo.name, tostring(cvo[2]), 
						tvo.colorName, tostring(neednum * Lua_CommonUtil.getCommonConfig("script_clean_gold",1)), tvo.colorName);
						Lua_WindowUtil.openWin("Lua_ItemDirectBuyWindow", nil, {owner = self, callBack = self.onItemDirectOk, itemId = cvo[1], needNum = cvo[2], info = str});
						return;
					end
				end
				Lua_CopyUtil.saoDangCopy(Lua_CopyData.JUHUN_COPY, 1);
			end
		end
	else
		if copyInfoData.script_type == 0 then
			return;
		end
		if copyInfoData.free_times == 0 then
			if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.COPPER_AND_BINDCOPPER, self.needMoney, true, true) == false then
				return;
			end
		end
		sendMsg(10404111);
	end
end

function Lua_JuHunZhuanPanWindow:onItemDirectOk()
	Lua_CopyUtil.saoDangCopy(Lua_CopyData.JUHUN_COPY, 1);
end

function Lua_JuHunZhuanPanWindow:onZhuanPanResult(o)
	if self.isSaoDang == true then
		self.curIndex = self.curIndex + 1;
		if self.curIndex > 5 then
			self:onShowMonster();
		else
			self.insideEnd = false;
			self.outsideEnd = false;

			local cw = self.saoDangData.wheel_record[self.curIndex];
			self.insideRot:setParams(400, 360 * 2 + (cw.obj_id - 1) * 45, self, self.onInsideEnd);
			self.outsideRot:setParams(-400, -360 * 3 + (cw.obj_value - 1) * 30, self, self.onOutsideEnd);
			self.insideRot:start();
			self.outsideRot:start();
		end
	else
		self.insideEnd = false;
		self.outsideEnd = false;
		
		self.insideRot:setParams(400, 360 * 2 + (o.cur_wheel.obj_id - 1) * 45, self, self.onInsideEnd);
		self.outsideRot:setParams(-400, -360 * 3 + (o.cur_wheel.obj_value - 1) * 30, self, self.onOutsideEnd);
		self.insideRot:start();
		self.outsideRot:start();
	end
end

function Lua_JuHunZhuanPanWindow:onInsideEnd(o)
	self.insideEnd = true;
	self:onAllEnd();
end

function Lua_JuHunZhuanPanWindow:onOutsideEnd(o)
	self.outsideEnd = true;
	self:onAllEnd();
end

function Lua_JuHunZhuanPanWindow:onAllEnd(o)
	if self.insideEnd == true and self.outsideEnd == true then
		if self.isSaoDang == true then
			self:updateSaoDangData();
			self.doNext = true;
		end
	end
end

function Lua_JuHunZhuanPanWindow:onSaveResult(o)
	if self.saveGray == true then
		return;
	end

	if self.insideEnd == false or self.outsideEnd == false then
		OperateAlert.show(LanUtil.getValue(121164));
		return;
	end

	local copyInfoData = DataCenter.copyInfoData;
	if copyInfoData.cur_wheel == nil then
		return;
	end

	if copyInfoData.cur_wheel.obj_id == 0 or copyInfoData.cur_wheel.obj_value == 0 then
		OperateAlert.show(LanUtil.getValue(121172));
		return;
	end
	sendMsg(10404113);
end

function Lua_JuHunZhuanPanWindow:updateBtnState()
	if self.isSaoDang == true then
		return;
	end

	local copyInfoData = DataCenter.copyInfoData;
	if copyInfoData.cur_wheel == nil or copyInfoData.finish_wave == nil then
		return;
	end

	if copyInfoData.cur_wheel.obj_id ~= 0 or copyInfoData.cur_wheel.obj_value ~= 0 then -- 结果没保存
		self:setStartGray(true);
		return;
	end

	if copyInfoData.finish_wave + 1 > 5 then -- 全部完成
		self:setStartGray(true);
		return;
	end

	if copyInfoData.finish_wave + 1 == copyInfoData.cur_wave then -- 正在打怪
		self:setStartGray(true);
		return;
	end

	if copyInfoData.wheel_record[copyInfoData.finish_wave + 1] == nil then -- 没有设置
		self:setStartGray(true);
		return;
	end
	self:setStartGray(false);
end

function Lua_JuHunZhuanPanWindow:setStartGray(val)
	self.refreshBtn:setAltas("common_atlas_1", val and "ui_common_btn_01" or "ui_common_btn_02");
	self.refreshTxt:setGray(val);
	self.refreshGray = val;
end

function Lua_JuHunZhuanPanWindow:onShowMonster(o)
	if self.refreshGray == true and o ~= 1 then
		return;
	end

	if self.insideEnd == false or self.outsideEnd == false then
		OperateAlert.show(LanUtil.getValue(121164));
		return;
	end

	if self.isSaoDang == true then
		self:hide();
		return;
	end

	-- local copyInfoData = DataCenter.copyInfoData;
	-- if copyInfoData.pause_tick ~= 0 then
	-- 	OperateAlert.show(LanUtil.getValue(121171));
	-- 	return;
	-- end

	sendMsg(10404112);
	if o ~= false then
		self:hide();
	end
end