Lua_CopyLimitTimeItem = class("Lua_CopyLimitTimeItem", Lua_DisplayObject);
function Lua_CopyLimitTimeItem:ctor(p)
	self:superCall("ctor", p, "CopyLimitTimeItem_skin");
end

function Lua_CopyLimitTimeItem:buildShowItem()
	self:superCall("buildShowItem");

	Lua_CommonUtil.addTimer("Lua_CopyLimitTimeItem", 0.2, self, self.onCountDown);
end

function Lua_CopyLimitTimeItem.Get:height()
	return self.timeLabel.height;
end

function Lua_CopyLimitTimeItem:updateData(msg)
	self.leftTime = msg.reward_tick;
	if msg.timeStartTime ~= nil then
		self.startTime = msg.timeStartTime;
	end
end

function Lua_CopyLimitTimeItem:onCountDown()
	if self.startTime ~= nil and self.leftTime ~= nil then
		local lt = self.leftTime - (getTime() - self.startTime);
		if lt < 0 then
			lt = 0;
		end

		if lt > self.leftTime then
			lt = self.leftTime;
		end

		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121137), tostring(math.floor(lt)));
	else
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121137), "0");
	end
end

function Lua_CopyLimitTimeItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);

	self:superCall("dispose");
end