Lua_CopyLingWenCellItem = class("Lua_CopyLingWenCellItem", Lua_ListCell);
function Lua_CopyLingWenCellItem:ctor(p)
	self:superCall("ctor", p, "CopyLingWenCellItem_skin");
end

function Lua_CopyLingWenCellItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.pos == 1 then
		self.bg:setAltas("copy_atlas_2", "ui_fuben_bg_18"); -- 底部大门
		self.bg:resetSize();
		self.floorTxt:setEnable(false);
		self.passBg:setEnable(false);
		self.passTxt:setEnable(false);
		self.btnSp:setEnable(false);
		self.lockSp:setEnable(false);
	elseif data.pos == 3 then
		self.bg:setAltas("copy_atlas_2", "ui_fuben_bg_16"); -- 顶部楼顶
		self.bg:resetSize();
		self.floorTxt:setEnable(true);
		self.passBg:setEnable(true);
		self.passTxt:setEnable(true);
		self.btnSp:setEnable(true);
	else
		self.bg:setAltas("copy_atlas_2", "ui_fuben_bg_08"); -- 中间楼层
		self.bg:resetSize();
		self.floorTxt:setEnable(true);
		self.passBg:setEnable(true);
		self.passTxt:setEnable(true);
		self.btnSp:setEnable(true);
	end

	if data.pos ~= 1 then
		if data.isPass then
			self.floorTxt.text = Lua_ColorDefine.colorStr(data.name, Lua_ColorDefine.WHITE_STR);
			self.lockSp:setEnable(false);
			self.passBg:setEnable(true);
			self.passTxt:setEnable(true);
			self.btnSp:setAltas("copy_atlas_2", "ui_fuben_bg_09"); -- 已通
			-- self.btnSp:setGray(false);
		elseif data.canChallenge then
			self.floorTxt.text = Lua_ColorDefine.colorStr(data.name, Lua_ColorDefine.GREEN_STR);
			self.lockSp:setEnable(false);
			self.passBg:setEnable(false);
			self.passTxt:setEnable(false);
			self.btnSp:setAltas("copy_atlas_2", "ui_fuben_bg_10"); -- 当前
			-- self.btnSp:setGray(false);
		else
			self.floorTxt.text = Lua_ColorDefine.colorStr(data.name, Lua_ColorDefine.RED_STR);
			self.lockSp:setEnable(true);
			self.passBg:setEnable(false);
			self.passTxt:setEnable(false);
			self.btnSp:setAltas("copy_atlas_2", "ui_fuben_bg_09"); -- 未通
			-- self.btnSp:setGray(true);
		end
	end
	self.leftIcon:setEnable(data.pos ~= 1 and data.canChallenge);
	self.rightIcon:setEnable(data.pos ~= 1 and data.canChallenge);
end

function Lua_CopyLingWenCellItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("LINGWEN_COPY_SELECT", self._data);
end