Lua_CopyMoneyItem = class("Lua_CopyMoneyItem", Lua_ListCell);
function Lua_CopyMoneyItem:ctor(p)
	self:superCall("ctor", p, "CopyMoneyItem_skin");
end

function Lua_CopyMoneyItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.img_name then
		self.difSp:setAltas(data.img_name[1], data.img_name[2]);
	end

	local copyVo = DataCenter.copyData:getCopyById(data.script_type);
	if data.open_level > DataCenter.roleData.level or data.starOk == false then
		if data.open_level > DataCenter.roleData.level then
			self.openTxt.text = LanUtil.formateStr(LanUtil.getValue(121107), tostring(data.open_level));
		else
			self.openTxt.text = LanUtil.formateStr(LanUtil.getValue(121117), tostring(data.open_star));
		end

		self.lockSp:setEnable(true);
		self.openTxt:setEnable(true);
		self.bg:setGray(true);
		self.difSp:setGray(true);
		self:setStarGray(0);
	elseif data.dif > 1 and copyVo:isDegressPass(data.dif - 1) == false then
		self.openTxt.text = LanUtil.getValue(121123);
		
		self.lockSp:setEnable(true);
		self.openTxt:setEnable(true);
		self.bg:setGray(true);
		self.difSp:setGray(true);
		self:setStarGray(0);
	else
		self.lockSp:setEnable(false);
		self.openTxt:setEnable(false);
		self.difSp:setGray(false);
		self.bg:setGray(false);
		
		local star = copyVo:getDegressStar(data.dif);
		if data.script_type == Lua_CopyData.JUHUN_COPY then
			self:setStarState(false);
		else
			self:setStarGray(star);
		end
	end
end

function Lua_CopyMoneyItem:setStarGray(val)
	for i = 1, 3 do
		if i > val then
			self["star"..i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing_s");
		else
			self["star"..i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing");
		end
	end
end

function Lua_CopyMoneyItem:setStarState(val)
	for i = 1, 3 do
		self["star"..i]:setEnable(val);
	end
end

function Lua_CopyMoneyItem:onPlayerSoundClick()
	Lua_MsgUtil.callFunc("COPY_MONEY_ITEM_SELECTED", self._data);
end