Lua_CopyNpcItem = class("Lua_CopyNpcItem", Lua_DisplayObject);
function Lua_CopyNpcItem:ctor(p)
	self:superCall("ctor", p, "CopyNpcItem_skin");
end

function Lua_CopyNpcItem:buildShowItem()
	self:superCall("buildShowItem");

	Lua_CommonUtil.addTimer("Lua_CopyNpcItem", 0.2, self, self.onCountDown);
end

function Lua_CopyNpcItem.Get:height()
	return self.infoTxt.height;
end

function Lua_CopyNpcItem:updateData(msg)
	self.script_type = msg.script_type;
	self.script_degree = msg.script_degree;
end

function Lua_CopyNpcItem:onCountDown(msg)
	local copyVo = DataCenter.copyData:getCopyById(self.script_type);
	local npcId = copyVo:getCopyProtectNpc(self.script_degree);
	local arr = DataCenter.thingData:getMonsterListByType(npcId);
	if arr ~= nil and arr:getSize() > 0 then
		self.infoTxt.text = LanUtil.formateStr(LanUtil.getValue(121151),arr[1].name, 
			Lua_CommonUtil.getNumberTrans(arr[1].hp), Lua_CommonUtil.getNumberTrans(arr[1].maxHp));
	else
		self.infoTxt.text = "";
	end
end

function Lua_CopyNpcItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);
	
	self:superCall("dispose");
end