Lua_CopyOneItem = class("Lua_CopyOneItem", Lua_ListCell);
function Lua_CopyOneItem:ctor(p)
	self:superCall("ctor", p, "CopyOneItem_skin");
end

function Lua_CopyOneItem:buildShowItem()
	self:superCall("buildShowItem");

	self.goBtn:addClickFuntion(self, self.onGotoClick);
	self.addSp:addClickFuntion(self, self.onAddClick);
end

function Lua_CopyOneItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = data.name;
	self.outTxt.text = data.output_des;

	if data.member_num ~= 1 then
		self.typeTxt.text = LanUtil.getValue(121101);
	else
		self.typeTxt.text = LanUtil.getValue(121100);
	end
	
	self.copyIcon:setAltas(data.atlas, data.icon_name);

	local profLevel = DataCenter.roleData.profession;
	if data:isOpened() == true then
		if data.id == Lua_CopyData.LINGWEN_COPY or data.id == Lua_CopyData.HUANLING_COPY then
			local d = data.degreeRecord == nil and 0 or data.degreeRecord;
			self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121125), tostring(d));
			self.timeDesTxt:setEnable(false);
			self.tvalueTxt:setEnable(false);
			self.timeTxt:setEnable(true);
		else
			if data.leftTimes == nil or data.sumTimes == nil then
				self.tvalueTxt.text = "[00E125]0/0[-]";
			else
				if data.leftTimes > data.sumTimes then
					self.tvalueTxt.text = "[00E125]"..data.leftTimes.."/"..data.leftTimes.."[-]";
				else
					self.tvalueTxt.text = "[00E125]"..data.leftTimes.."/"..data.sumTimes.."[-]";
				end
			end
			self.timeDesTxt:setEnable(true);
			self.tvalueTxt:setEnable(true);
			self.timeTxt:setEnable(false);
		end
		local posX = self.tvalueTxt.mainContent.transform.localPosition.x + self.tvalueTxt.width + self.addSp.width / 2 + 5;
		self.addSp:setLocation(posX, -31, 0);
		posX = self.addSp.mainContent.transform.localPosition.x + 18.5;
		self.isBuyTxt:setLocation(posX, -31.5, 0);

		-- local hasTime = data.leftTimes > 0; -- 剩余次数
		local leftBuyTimes = data.leftBuyTimes or 0; -- 可购买次数
		if leftBuyTimes <= 0 then
			self.isBuyTxt.text = LanUtil.getValue(120962); -- 已購買
		else
			self.isBuyTxt.text = LanUtil.getValue(120961); -- 可購買
		end
		self.circleBg2:setEnable(false);
		self.lockSp:setEnable(false);
		self.addSp:setEnable(data.config.cost ~= nil);
		self.isBuyTxt:setEnable(data.config.cost ~= nil);
	else
		if data.open_fun ~= nil then
			local tipsStr = getConfig({"func_open", data.open_fun,"advance_message"});
			self.timeTxt.text = "[FF1616]"..tipsStr.."[-]";
		end
		self.lockSp:setEnable(true);
		self.circleBg2:setEnable(true);
		self.timeDesTxt:setEnable(false);
		self.tvalueTxt:setEnable(false);
		self.timeTxt:setEnable(true);
		self.addSp:setEnable(false);
		self.isBuyTxt:setEnable(false);
	end

	if data ~= nil and data.evenIds ~= nil then
		self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.refreshRedDot); -- 图标红点更新
	end
	self:refreshRedDot();
end

function Lua_CopyOneItem:refreshRedDot()
	if self._data ~= nil and self._data.evenIds ~= nil then
		if  self._data:isOpened() == true then
			for i = 1, #self._data.evenIds do
				local bShow = DataCenter.redDotData:getRedDotStateByEventId(self._data.evenIds[i]);
				if bShow == true then
					self.redDot:setEnable(true);
					return;
				end
			end
		end
	end
	self.redDot:setEnable(false);
end

function Lua_CopyOneItem:onGotoClick(go)
	if DataCenter.roleData.level < self._data.open_lv or DataCenter.roleData.profession < self._data.prof_level  or self._data:isOpened() == false then
		OperateAlert.show(LanUtil.getValue(121115));
		return;
	end

	if self._data.win_name ~= nil then
		Lua_WindowUtil.openWin(self._data.win_name, nil, self._data);
	end
end

function Lua_CopyOneItem:onAddClick(o)
	local copyVo = self._data;
	local t = copyVo.leftBuyTimes;
	if t == nil then
		t = 0;
	end

	local info = {owner = self, configSign = copyVo.vip_index, residueTimes = t, costList = copyVo:getBuyTimeCostList(),
	costType = copyVo:getBuyTimeCostType(), useGold = 1, callback = self.onBuyTimes};
	if copyVo.id == Lua_CopyData.YINYUAN_COPY then
		Lua_WindowUtil.openWin("Lua_CopyYinYuanTipsWindow", WinParam.ACTION_OPEN, info);
	else
		Lua_WindowUtil.openWin("Lua_BuyTimesWindow", WinParam.ACTION_OPEN, info);
	end
end

function Lua_CopyOneItem:onBuyTimes(val)
	Lua_CopyUtil.buyCopyTime(self._data.id, val)
end