Lua_CopyShenLianItem = class("Lua_CopyShenLianItem", Lua_DisplayObject);
function Lua_CopyShenLianItem:ctor(p)
	self:superCall("ctor", p, "CopyShenLianItem_skin");
end
function Lua_CopyShenLianItem:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("ROLE_BUFF_UPDATE",self,self.onBuffUpdate);
	self:addTimer("jieSuCountDown", 1, self, self.onCountDown);
end

function Lua_CopyShenLianItem:updateData(msg)
	self.jishaTxt.text = tostring(msg.kill_monster);
	self.guwuTxt.text = msg.percent.."%";
	self:onBuffUpdate();

	if msg.extra_tick > 0 then
		self.leftTime = msg.extra_tick;
	else
		self.leftTime = msg.left_tick;
	end
	if msg.timeStartTime ~= nil then
		self.startTime = msg.timeStartTime + msg.ready_tick;
	end

	if msg.nowTime ~= nil then
		self.nowTime = msg.nowTime;
	end
	
	self.slow_tick = msg.slow_tick;
	if self.slow_tick ~= nil and self.slow_tick > 0 then
		Lua_CommonUtil.addTimer("onJianSuCountDown", 0.2, self, self.onJianSuCountDown);
	else
		self.jiansuTxt.text = LanUtil.getValue(129004);
	end

	self.jieduanTxt.text = tostring(msg.cur_wave);
	self.shengyuTxt.text = tostring(msg.left_monster);
	self.taotuoTxt.text = tostring(msg.escape_monster);
end
function Lua_CopyShenLianItem:onBuffUpdate(o)
	local buffId = Lua_CommonUtil.getCommonConfig("shenyou_buff", 1);
	local buffData = DataCenter.roleData:getBuffById(buffId, true);
	if buffData == nil then
		self.shenshouTxt.text = "0%";
	else
		self.shenshouTxt.text = buffData.value2.."%";
	end
end

function Lua_CopyShenLianItem:onCountDown()
	if self.startTime ~= nil and self.leftTime ~= nil then
		local lt = self.leftTime - (getTime() - self.startTime);
		if lt < 0 then
			lt = 0;
		end
		if lt > self.leftTime then
			lt = self.leftTime;
		end
		local colorStr = Lua_ColorDefine.GREEN_STR;
		if lt <= 10 then
			colorStr = Lua_ColorDefine.RED_STR;
		end
		self.timeTxt.text = "["..colorStr.."]"..TimeTransform.getInstance():transSeconds6(math.floor(lt), true, true).."[-]";
	else
		self.timeTxt.text = "["..Lua_ColorDefine.GREEN_STR.."]00:00:00[-]";
	end
end

function Lua_CopyShenLianItem:onJianSuCountDown()
	local lt = self.slow_tick - (getTime() - self.nowTime);
	if lt > 0 then
		self.jiansuTxt.text = LanUtil.formateStr(LanUtil.getValue(129005), TimeTransform.getInstance():transSeconds8(lt, "ss"));
	else
		self.jiansuTxt.text = LanUtil.getValue(129004);
		Lua_CommonUtil.removeTimer(self, self.onJianSuCountDown);
	end	
end

function Lua_CopyShenLianItem.Get:height()
	return 200;
end

function Lua_CopyShenLianItem:dispose()
	self:superCall("dispose");
end