Lua_CopyShenYouItem = class("Lua_CopyShenYouItem", Lua_ListCell);
function Lua_CopyShenYouItem:ctor(p)
	self:superCall("ctor", p, "CopyShenYouItem_skin");
end

function Lua_CopyShenYouItem:buildShowItem()
	self:superCall("buildShowItem");

	self.img = Lua_ToolImage.new(self.content);
	self.img:setDepth(3);
	self.img:setLocation(-222, 5, 0);

	self.subBtn:addClickFuntion(self, self.onClickFun);
end

function Lua_CopyShenYouItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.img.data = Lua_ToolVo.createToolVo(data.id, data.num, 1);
	self.deaLabel.text = data.des;

	if data.num > 0 then
		self.subBtn.label = LanUtil.getValue(110822);
	else
		self.subBtn.label = LanUtil.getValue(121703);
	end
end

function Lua_CopyShenYouItem:onClickFun(go)
	local packData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
	local bagNum = packData:getItemNum(self.data.id);
	if bagNum <= 0 then
		local tvo = Lua_ToolVo.createToolVo(self.data.id, self.data.num, 1);
		local tipData = {};
		tipData.owner = self;
		tipData.des = LanUtil.formateStr(LanUtil.getValue(121152),
			tostring(tvo.goldPrice), tostring(tvo.goldPrice), tvo.colorName);
		tipData.type = 1;
		tipData.subFun = self.onBuyItem;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	else
		local arr = packData:getItemsById(self.data.id);
		if arr:getSize() > 0 then
			Lua_PackUtil.useItem(arr[1], 1);
		end
		Lua_WindowUtil.openWin("Lua_CopyShenYouWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_CopyShenYouItem:onBuyItem(go)
	local tvo = Lua_ToolVo.createToolVo(self.data.id, self.data.num, 1);
	local showType = -1;
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.BIND_GOLD, tvo.goldPrice, false, false) == true then
		showType = 5;
	end

	if showType == -1 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD, tvo.goldPrice, true, true) == true then
			showType = 2;
		end
	end

	if showType ~= -1 then
		Lua_PackUtil.buyItem(self.data.id, showType, 1, true);
		Lua_WindowUtil.openWin("Lua_CopyShenYouWindow", WinParam.ACTION_CLOSE);
	end
end

function Lua_CopyShenYouItem:dispose()
	if self.img ~= nil then
		self.img:dispose();
		self.img = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end