Lua_CopyStarItem = class("Lua_CopyStarItem", Lua_DisplayObject);
function Lua_CopyStarItem:ctor(p)
	self:superCall("ctor",p, "CopyStarItem_skin");
end

function Lua_CopyStarItem:buildShowItem()
	self:superCall("buildShowItem");

	Lua_CommonUtil.addTimer("Lua_CopyTimeItem", 0.2, self, self.onCountDown);
end

function Lua_CopyStarItem.Get:height()
	return 172.5;
end

function Lua_CopyStarItem:updateData(msg)
	self.script_type = msg.script_type;
	self.startTime = msg.starStartTime;
	self.leftTime = msg.left_time;
	self.curStar = msg.cur_star;

	self.wholeTime = msg.left_tick;
	self.wholeStartTime = msg.timeStartTime + msg.ready_tick;

	self.canCountDown = true;
	if msg.extra_tick > 0 then
		self.canCountDown = false;
		self.showTime = self.leftTime - (getTime() - self.startTime);
	end
end

function Lua_CopyStarItem:onCountDown()
	if self.startTime ~= nil and self.leftTime ~= nil then
		local lt = 0;
		if self.canCountDown == true then
			lt = self.leftTime - (getTime() - self.startTime);
		else
			lt = self.showTime;
		end
		if lt < 0 then
			lt = 0;
		end
		local str = TimeTransform.getInstance():transSeconds6(math.floor(lt), false, true);
		local s = self.curStar - 1;

		local lanNum = 121112;
		if self.script_type == Lua_CopyData.XIELING_COPY then
			local hlt = self.wholeTime - (getTime() - self.wholeStartTime);
			if s < 0 or hlt < lt then
				lanNum = 121131;
				s = 0;
				str = TimeTransform.getInstance():transSeconds6(math.floor(hlt), false, true);
			end
		else
			if s < 0 then
				s = 0;
			end
			if s == 0 then
				lanNum = 121131;
			end
		end

		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(lanNum), str, tostring(s));
		self:setStarNum(self.curStar);
	else
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121112), "00:00", "0") ;
		self:setStarNum(3);
	end
end

function Lua_CopyStarItem:setStarNum(val)
	for i = 1, 3 do
		-- self["star"..i]:setGray(i > val);
		if i > val then
			self["star"..i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing_s");
		else
			self["star"..i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing");
		end
	end
end

function Lua_CopyStarItem:dispose()
	Lua_CommonUtil.removeTimer(self, self.onCountDown);

	self:superCall("dispose");
end