Lua_CopyTimeItem = class("Lua_CopyTimeItem", Lua_DisplayObject);
function Lua_CopyTimeItem:ctor(p)
	self:superCall("ctor", p, "CopyTimeItem_skin");
end

function Lua_CopyTimeItem:buildShowItem()
	self:superCall("buildShowItem");

	Lua_CommonUtil.addTimer("Lua_CopyTimeItem", 0.2, self, self.onCountDown);
	self.infoSp:addClickFuntion(self, self.onInfoClick);
end

function Lua_CopyTimeItem.Get:height()
	return self.timeLabel.height;
end

function Lua_CopyTimeItem:updateData(msg)
	if msg.extra_tick > 0 then
		self.leftTime = msg.extra_tick;
	else
		self.leftTime = msg.left_tick;
	end

	if msg.timeStartTime ~= nil then
		self.startTime = msg.timeStartTime + msg.ready_tick + msg.pause_last_time;
	end

	if msg.script_type == Lua_CopyData.JUHUN_COPY then
		self.startTime = msg.wave_start_time;
		self.leftTime = msg.wave_time;
		self.timeLabel.text = LanUtil.getValue(121179);
	else
		self.timeLabel.text = LanUtil.getValue(121180);
	end
	self.timeTxt:setLocation(self.timeLabel.mainContent.transform.localPosition.x + self.timeLabel.width, self.timeLabel.mainContent.transform.localPosition.y, 0);
end

function Lua_CopyTimeItem:showInfoBtn(val)
	self.infoSp:setEnable(val);
end

function Lua_CopyTimeItem:onCountDown()
	local infoData = DataCenter.copyInfoData;
	if infoData.pause_start_time ~= 0 then
		return;
	end
	if self.startTime ~= nil and self.leftTime ~= nil then
		local lt = self.leftTime - (getTime() - self.startTime);
		if lt < 0 then
			lt = 0;
		end
		if lt > self.leftTime then
			lt = self.leftTime;
		end
		local colorStr = Lua_ColorDefine.GREEN_STR;
		if lt <= 10 and self.leftTime ~= 0 then
			colorStr = Lua_ColorDefine.RED_STR;
		end
		self.timeTxt.text = "["..colorStr.."]"..TimeTransform.getInstance():transSeconds6(math.floor(lt), true, true).."[-]";
	else
		self.timeTxt.text = "["..Lua_ColorDefine.GREEN_STR.."]00:00:00[-]";
	end
end

function Lua_CopyTimeItem:onInfoClick(o)
	local copyVo = DataCenter.copyData:getCopyById(DataCenter.copyInfoData.script_type);
	if copyVo == nil or copyVo.lang_id == 0 then
		return;
	end
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(copyVo.lang_id));
end

function Lua_CopyTimeItem:dispose()
	self:superCall("dispose");

	Lua_CommonUtil.removeTimer(self, self.onCountDown);
end