Lua_JueXingItem = class("Lua_JueXingItem", Lua_ListCell);
function Lua_JueXingItem:ctor(p)
	self:superCall("ctor", p, "JueXingItem_skin");
end

function Lua_JueXingItem:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("COPY_MATCH_NUMBER", self, self.onUpdateMatchNumber);
end

function Lua_JueXingItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local iconName = {"ui_fuben_nandu_jiandan2", "ui_fuben_nandu_putong2", "ui_fuben_nandu_kunnan2", "ui_fuben_nandu_jingying2",
	"ui_fuben_nandu_diyu2", "ui_fuben_nandu_fengkuang2", "ui_fuben_nandu_shishi2"};
	self.diffSp:setAltas("copy_atlas_1", iconName[data.dif]);

	local copyVo = DataCenter.copyData:getCopyById(data.script_type);
	if data.selected == true then
		self.selectedSp:setEnable(true);
	else
		self.selectedSp:setEnable(false);
	end

	if data.open_level > DataCenter.roleData.level or data.starOk == false then
		if data.open_level > DataCenter.roleData.level then
			self.txt.text = LanUtil.formateStr(LanUtil.getValue(121107), tostring(data.open_level));
		else
			self.txt.text = LanUtil.formateStr(LanUtil.getValue(121117), tostring(data.open_star));
		end
		self.txt:setEnable(true);
		self.lockIcon:setEnable(true);

		self.bg:setGray(true);
		self.diffSp:setGray(true);
		self.macthTxt:setEnable(false);
	elseif data.dif > 1 and copyVo:isDegressPass(data.dif - 1) == false then
		self.txt.text = LanUtil.getValue(121123);
		self.txt:setEnable(true);
		self.lockIcon:setEnable(true);

		self.bg:setGray(true);
		self.diffSp:setGray(true);
		self.macthTxt:setEnable(false);
	else
		self.txt:setEnable(false);
		self.lockIcon:setEnable(false);

		self.bg:setGray(false);
		self.diffSp:setGray(false);
		self.macthTxt:setEnable(true);
		self.macthTxt.text = "";
		self:onUpdateMatchNumber();
	end
end

function Lua_JueXingItem:onUpdateMatchNumber()
	local copyVo = DataCenter.copyData:getCopyById(self._data.script_type);
	local num = copyVo:getMatch(self._data.dif);
	self.macthTxt.text = LanUtil.formateStr(LanUtil.getValue(122270), tostring(num));
end

function Lua_JueXingItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("JUSXING_COPY_SELECT", self._data);
end