Lua_XieLingItem = class("Lua_XieLingItem", Lua_ListCell);
function Lua_XieLingItem:ctor(p)
	self:superCall("ctor", p, "XieLingItem_skin");
end

function Lua_XieLingItem:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("COPY_MATCH_NUMBER", self, self.onUpdateMatchNumber);
end

function Lua_XieLingItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.monsterImg:setUrl(data.monster_img);

	self.nameTxt.text = data.name;
	self.lvTxt.text = "LV"..data.open_level;

	local md = Lua_MonsterConfigData.new(data.monster_id);
	self.monsterTxt.text = md.name;

	if self._data.open_level > DataCenter.roleData.level then
		self.bg:setGray(true);
		self.nameTxt:setGray(true);
		self.lvTxt:setGray(true);
		self.monsterTxt:setGray(true);
		self.monsterImg:setGray(true);
		self.macthTxt:setEnable(false);
		self.limiTxt:setEnable(true);
	else
		self.bg:setGray(false);
		self.nameTxt:setGray(false);
		self.lvTxt:setGray(false);
		self.monsterTxt:setGray(false);
		self.monsterImg:setGray(false);
		self.macthTxt:setEnable(true);
		self.limiTxt:setEnable(false);
		
		self:onUpdateMatchNumber();
	end
	self.selectedSp:setEnable(data.selected);
end

function Lua_XieLingItem:onUpdateMatchNumber()
	local copyVo = DataCenter.copyData:getCopyById(self._data.script_type);
	local num = copyVo:getMatch(self._data.dif);
	self.macthTxt.text = LanUtil.formateStr(LanUtil.getValue(122270), tostring(num));
end

function Lua_XieLingItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("XIELING_COPY_SELECT", self._data);
end