Lua_CopyMoneyResultItem = class("Lua_CopyMoneyResultItem", Lua_DisplayObject);
function Lua_CopyMoneyResultItem:ctor(p)
	self:superCall("ctor", p, "CopyMoneyResultItem_skin");
end

function Lua_CopyMoneyResultItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_RewardDragItem.new(self.content, 700);
	self.rewardItem.pivot = 2;
	self.rewardItem:setLocation(0, 0, 0);
	self.rewardItem:setDepth(5);
end

function Lua_CopyMoneyResultItem:updateData(msg)
	local copyVo = nil;
	if msg.script_type ~= nil then
		copyVo = DataCenter.copyData:getCopyById(msg.script_type);
	end

	local arr = Array();
	if msg.items == nil then
		for i,v in ipairs(msg.reward) do
			if v.id ~= 0 then
				arr:add(v);
			end
		end
	else
		for i,v in ipairs(msg.items) do
			if v.id ~= 0 then
				arr:add(v);
			end
		end
	end

	if copyVo == nil or copyVo.moneys == nil then
		self.midTxt.text = "";
	else
		local len = arr:getSize();
		local moneys = copyVo.moneys;
		local moneyNum = {};
		local i = 1;
		while true and len > 0 do
			if table.indexOf(moneys, arr[i].id) ~= -1 then
				if moneyNum[arr[i].id] == nil then
					moneyNum[arr[i].id] = 0;
				end
				moneyNum[arr[i].id] = moneyNum[arr[i].id] + arr[i].amount;
				arr:remove(i);
				i = i -1;
				len = len - 1;
			end
			i = i + 1;
			if i > len then
				break;
			end
		end

		if table.indexOf(moneys, Lua_MoneyData.EXP) ~= -1 then
			local expNum = tonumber(tostring(msg.exp));
			if expNum > 0 then
				moneyNum[Lua_MoneyData.EXP] = expNum;
			end
		end

		i = 1;
		local mstr = "";
		for k,v in pairs(moneyNum) do
			local toolvo = Lua_ToolVo.createToolVo(k, 1, 0);
			if i ~= 1 then
				mstr = mstr.."    ";
			end
			mstr = mstr..LanUtil.formateStr(LanUtil.getValue(121113), toolvo.name, Lua_CommonUtil.getNumberTrans(v));
			i = i + 1;
		end
		self.midTxt.text = mstr;
	end

	local itemDic = {};
	local rsList = Array();
	for i = 1, arr:getSize() do
		local iid = arr[i].id;
		local tvo = Lua_ToolVo.createToolVo(arr[i].id, 1, 0);
		tvo:fromServer(arr[i]);
		if tvo.overlap > 1 and tvo.bShowItemBg == true then
			local keyStr = iid..""..arr[i].bind;
			if itemDic[keyStr] == nil then
				itemDic[keyStr] = tvo;
			else
				itemDic[keyStr].count = itemDic[keyStr].count + arr[i].count;
			end
		else
			local count = arr[i].amount;
			tvo.count = 1;
			for j = 1, count do
				rsList:add(tvo);
			end
		end
	end
	
	for k,v in pairs(itemDic) do
		rsList:add(v);
	end
	self.rewardItem:setRewardByArray(rsList);
	self.rewardItem:setEnable(rsList:getSize() > 0);

	--self.midTxt:setEnable(false);
	self:checkLingWenOpen(msg);
	self:checkIsJunHun(msg);
	self:checkIsHuanLing(msg);
end

function Lua_CopyMoneyResultItem:checkLingWenOpen(msg)
	if msg.script_type == Lua_CopyData.LINGWEN_COPY then -- 灵纹副本开启灵纹孔要显示
		local unlock_cond = getConfig({"rune", "groove_unlock_cond"});
		local unlock = false;--解锁新符文孔
		local str = "";
		local showTxt = 0;
		if unlock_cond ~= nil then
			for i,v in ipairs(unlock_cond) do
				if v == msg.script_degree then
					unlock = true;
				end
			end
		end

		if unlock then
			str = str..LanUtil.getValue(121141);
			showTxt = 1;
		end

		local unlockItem = getConfig({"rune", "type_unlock_item", msg.script_degree});
		if unlockItem ~= nil then--解锁新符文
			if unlock then
				str = str.."\n\n";
			end
			local tvo = Lua_ToolVo.createToolVo(unlockItem, 1, 1);
			str = str..LanUtil.formateStr(LanUtil.getValue(121142), tvo.name);
			showTxt = 1;
		end

		if showTxt == 1 then
			self.midTxt.text = str;
		end
	end
end

function Lua_CopyMoneyResultItem:checkIsJunHun(msg)
	if msg.script_type == Lua_CopyData.JUNHUN_COPY then
		if msg.special_items ~= nil and #msg.special_items > 0 then
			self.rewardItem:setLocation(0, 0, 0);

			self.label = UICreate.createLabel(self.content, "", 0, -100, 500, 30, 20);
			self.label.overflowMethod = UILabel.Overflow.ResizeFreely;
			self.label.pivot = UIWidget.Pivot.Center;
			self.label.spacingY = 10;
			self.label:setDepth(5);
			self.label.text = LanUtil.getValue(129302);

			self.special_rewardItem = Lua_RewardDragItem.new(self.content, 700);
			self.special_rewardItem.pivot = 2;
			self.special_rewardItem:setLocation(0, -150, 0);
			self.special_rewardItem:setDepth(5);

			local arr = Array();
			for i,v in ipairs(msg.special_items) do
				if v.id ~= 0 then
					arr:add(v);
				end
			end
			self.special_rewardItem:setRewardByArray(arr);
		end
	end
end

function Lua_CopyMoneyResultItem:checkIsHuanLing(msg)
	if msg.script_type == Lua_CopyData.HUANLING_COPY then
		self.midTxt.text = LanUtil.getValue(141805);
	end
end

function Lua_CopyMoneyResultItem:setDepth(val)
	self:superCall("setDepth", val);

	self.rewardItem:setDepth(val);
end