checkRequire("Lua_Longmai_MissionItem")
checkRequire("Lua_OutTimeItem");
Lua_LongmaiPanel = class("Lua_LongmaiPanel", Lua_DisplayObject);
function Lua_LongmaiPanel:ctor(p)
	self:superCall("ctor", p, "LongmaiPanel_skin");
end

function Lua_LongmaiPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardInfoArr = Array();

	self.curModelIndex = 1;
	self.longmaiName = getConfig({"total_config", "exterior", "name_value"});
	self.longmaiLv = getConfig({"total_config", "exterior", "arr_value"});
	self.longMaiAttrArr = DataCenter.longmaiData.longMaiAttrArr;

	self.lvTxt.text = LanUtil.getValue(121905)..tostring(self.longMaiAttrArr[1].id);
	self.upgradeLabel.text = LanUtil.getValue(121906);
	self.upgradeBtnRedDot:setEnable(false);

	self.expBar:setText(tostring(0) .. "/" .. tostring(self.longMaiAttrArr[1].progress_val));
	self.expBar:setMaxValue(self.longMaiAttrArr[1].progress_val);
	self.expBar:setValue(0);

	self.activeBar:setText("");
	self.activeBar:setMaxValue(1000);
	self.activeBar:setValue(0);

	self.fightNum = Lua_NumberImage.new(self.leftObj);
	self.fightNum.numWidth = 13;
	self.fightNum:setDepth(3);
	self.fightNum:setLocation(-273, 192, 0);

	local imgPos = Vector2(-296, 90);
	local imgSize = Vector2(762, 524);
	local modelRot = Vector3(0, 180, 0);
	local modelOffset = Vector2(0, -900);

	self.modelTexture = UIModelTexture();
	self.modelTexture:setCamColor(Lua_ColorDefine.transColor("606060", 0));
	self.modelTexture:setShader("Unlit/Transparent Colored");
	self.modelTexture:init(self.leftObj, imgPos, imgSize, 3, modelRot, modelOffset, 550);
	self.modelTexture:setRotEnable(false, 0, 0, 900, 400, 2);
	self.modelTexture:setModelAngle(0, 0, 0)
	self.modelTexture:setAction(0);

	self.outTimeItem = Lua_OutTimeItem.new(self.content);

	self.missionItemList = Lua_DragList.new(self.rightObj, 1, Vector4(0, 0, 464, 430));
	self.missionItemList:setListCell(Lua_Longmai_MissionItem, 90, 464 , 1);
	self.missionItemList:setLocation(277, 3, 0);

	self.prevBtn:addClickFuntion(self, self.onPrevClick);
	self.nextBtn:addClickFuntion(self, self.onNextClick);
	self.hideChk:addBoxChange(self, self.hideEffectModel);
	self.infoSp:addClickFuntion(self, self.onInfoSpClick);
	self.upgradeBtn:addClickFuntion(self, self.onUpgradeClick);

	self:updateBtnRed();
	
	self:addLuaEvent("UPDATE_LONGMAI_INFO", self, self.updateLongMaiInfo)
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.refreshRedDot);
	DataCenter.longmaiData:sOpenLongmaiWin();
end

function Lua_LongmaiPanel:updateBtnRed()
	local redState = DataCenter.redDotData:getRedDotStateByEventId(11143);
	self.upgradeBtnRedDot:setEnable(redState);
	self:updateBtn(redState);
end

function Lua_LongmaiPanel:updateBtn(state)
	if state then
		self.upgradeBtn:setAltas("common_atlas_1", "ui_common_btn_02");
		self.upgradeLabel.text = "[FFFFFF]" .. LanUtil.getValue(121906);
	else
		self.upgradeBtn:setAltas("common_atlas_1", "ui_common_btn_p7");
		self.upgradeLabel.text = "[79808C]" .. LanUtil.getValue(121906);
	end
end

function Lua_LongmaiPanel:updateLongMaiInfo(msg)
	if msg == nil then
		return;
	end
	self.serverInfo = msg;

	self.hideChk.seleted = msg.is_show == 0;
	self.lvTxt.text = LanUtil.getValue(121905) .. msg.current_lvl;

	local curLv = msg.current_lvl
	local curHealth = self.longMaiAttrArr[curLv].health;
	local curAttack = self.longMaiAttrArr[curLv].attack;
	local curDefence = self.longMaiAttrArr[curLv].defence;
	local nextHealth = self.longMaiAttrArr[curLv + 1].health;
	local nextAttack = self.longMaiAttrArr[curLv + 1].attack;
	local nextDefence = self.longMaiAttrArr[curLv + 1].defence;
	if curLv < self.longMaiAttrArr:getSize() then
		self.hpTxt.text = curHealth .. "  " .. "[00E125]+" .. (nextHealth - curHealth) .. "[-]";
		self.attackTxt.text = curAttack .. "  " .. "[00E125]+" .. (nextAttack - curAttack) .. "[-]";
		self.defenceTxt.text = curDefence .."  " .. "[00E125]+" .. (nextDefence - curDefence) .. "[-]";

		self.expBar:setText(msg.have_value .. "/" .. (self.longMaiAttrArr[curLv].progress_val));
		self.expBar:setMaxValue(self.longMaiAttrArr[curLv].progress_val);
		self.expBar:setValue(msg.have_value);
	else
		self.hpTxt.text = curHealth;
		self.attackTxt.text = curAttack;
		self.defenceTxt.text = curDefence;

		self.expBar:setText(LanUtil.getValue(121311));
		self.expBar:setMaxValue(msg.have_value);
		self.expBar:setValue(msg.have_value);
	end
	local param = {attack = tonumber(curAttack), blood = tonumber(curHealth), defence = tonumber(curDefence)};
	self.fightNum.num = Lua_FightUtil.caculateConfigForce(param);

	self.missionItemList:setLuaArrayData(DataCenter.longmaiData.missionList, false);

	local item;
	local startPosX = self.activeBar.mainContent.transform.localPosition.x - self.activeBar.width / 2 - 25;
	local posX;
	local posY = self.activeBar.mainContent.transform.localPosition.y;
	local len = #msg.rewards_info;
	local preActPoint;
	local nextActPoint;
	local unitPoint = 1 / len * msg.rewards_info[len].need_value;
	local changePoint;
	local endPoint;
	for i = 1, len do
		posX = startPosX + i / len * self.activeBar.width;
		item = self.rewardInfoArr[i];
		if item == nil then
			item = Lua_LongMaiActRewardItem.new(self.rightObj);
			item:setLocation(posX, posY, 0);
			self.rewardInfoArr:add(item);
		end
		item:setData(msg.rewards_info[i]);

		if i == 1 then
			endPoint = msg.obtain_value;
		else
			preActPoint = msg.rewards_info[i - 1].need_value;
			nextActPoint = msg.rewards_info[i].need_value;
			if msg.obtain_value > preActPoint and msg.obtain_value <= nextActPoint then
				changePoint = (nextActPoint - preActPoint) * (msg.obtain_value - preActPoint) / unitPoint;
				endPoint = preActPoint + changePoint;
			end
		end
	end

	self.activeDesLab.text = msg.obtain_value;
	self.activeBar:setText("");
	self.activeBar:setMaxValue(msg.rewards_info[len].need_value);
	self.activeBar:setValue(endPoint);
	
	for i = 1, #self.longmaiLv do
		if i < 10 then
			if msg.current_lvl >= self.longmaiLv[i] and msg.current_lvl < self.longmaiLv[i + 1] then
				self.curModelIndex = i;
				self:showCurModule(self.curModelIndex);
			end
		else
			if msg.current_lvl >= self.longmaiLv[i] then
				self.curModelIndex = i;
				self:showCurModule(self.curModelIndex);
			end
		end
	end

	if self.isFirst ~= true then
		self.isFirst = true;
		self:updateRewardsRed();
	end
end

function Lua_LongmaiPanel:refreshRedDot(obj)
	if obj ~= nil then
		if tonumber(obj.evenId) == 11143 then
			self:updateBtnRed();
		elseif tonumber(obj.evenId) == 11142 then
			self:updateRewardsRed();
		end
	end
end

function Lua_LongmaiPanel:updateRewardsRed()
	if self.isFirst ~= true then
		return;
	end
end

function Lua_LongmaiPanel:onPrevClick(go)
	if self.curModelIndex > 1 then
		self.curModelIndex = self.curModelIndex - 1;
	end
	self:showCurModule(self.curModelIndex);
end

function Lua_LongmaiPanel:onNextClick(go)
	if self.curModelIndex < #self.longmaiLv then
		self.curModelIndex = self.curModelIndex + 1;
	end
	self:showCurModule(self.curModelIndex);
end

function Lua_LongmaiPanel:showCurModule(index)
	if self.longmaiName ~= nil and self.longmaiName[index] ~= nil then
		self.nameTxt.text = self.longmaiName[index];
	end

	self.petStateTxt.text = LanUtil.formateStr(LanUtil.getValue(121900), tostring(self.longmaiLv[index]));
	self.petStateTxt:setEnable(self.serverInfo.current_lvl < self.longmaiLv[index]);

	local longmaiModelId = 1100000 + index;
	local modelInfo =  DataCenter.longmaiData:longMaiModelInfo(longmaiModelId);
	if modelInfo == nil then
		self.modelTexture:setUrl("/mounts/dragon01", string.format(longmaiModelId));
	else
		self.modelTexture:setUrl(modelInfo.floder .. "/" .. modelInfo.fileName, tostring(modelInfo.modelName));
	end

	self:setSwitchBtn(index);
end

function Lua_LongmaiPanel:setSwitchBtn(index)
	if index <= 1 then
		self.prevBtn.mouseEnable = false;
		self.prevBtn.uiwidget.spriteName = "ui_common_jiantou_02";
		self.prevBtn:setSacle(1, 1, 1);

		self.nextBtn.mouseEnable = true;
		self.nextBtn.uiwidget.spriteName = "ui_common_jiantou_01";
	elseif index >= #self.longmaiLv then
		self.prevBtn.mouseEnable = true;
		self.prevBtn.uiwidget.spriteName = "ui_common_jiantou_01";

		self.nextBtn.mouseEnable = false;
		self.nextBtn.uiwidget.spriteName = "ui_common_jiantou_02";
		self.nextBtn:setSacle(1, 1, 1);
	else
		self.nextBtn.mouseEnable = true;
		self.nextBtn.uiwidget.spriteName = "ui_common_jiantou_01";

		self.prevBtn.mouseEnable = true;
		self.prevBtn.uiwidget.spriteName = "ui_common_jiantou_01";
	end
end

-- 1显示，0隐藏
function Lua_LongmaiPanel:hideEffectModel(state)
	if state then
		DataCenter.longmaiData:sChangeLongmai(0);
	else
		DataCenter.longmaiData:sChangeLongmai(1);
	end
end

function Lua_LongmaiPanel:onInfoSpClick(go)
	Lua_WindowUtil.openWin("Lua_LongmaiRuleWindow");
end

function Lua_LongmaiPanel:onUpgradeClick(go)
	DataCenter.longmaiData:sLongmaiUpgrade();
end

function Lua_LongmaiPanel:dispose()
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose()
		self.modelTexture = nil;
	end
	if self.outTimeItem ~= nil then
		self.outTimeItem:dispose()
		self.outTimeItem = nil;
	end
	if self.missionItemList ~= nil then
		self.missionItemList:dispose()
		self.missionItemList = nil;
	end
	if self.rewardInfoArr ~= nil then
		self.rewardInfoArr:dispose()
		self.rewardInfoArr:clear()
		self.rewardInfoArr = nil;
	end

	self:superCall("dispose")
end





--------------------------------------------------





Lua_LongMaiActRewardItem = class("Lua_LongMaiActRewardItem", Lua_DisplayObject);
function Lua_LongMaiActRewardItem:ctor(p)
	self:superCall("ctor", p, "LongMaiActRewardItem_skin");
end

function Lua_LongMaiActRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(10);
	self.itemImg:setScale(0.8, 0.8);

	self.drawIcon.alpha = 0.1;

	self.redDot:setParent(self.itemImg.mainContent.transform);
	self.redDot:setLocation(self.itemImg.item_bg.width / 2, self.itemImg.item_bg.height / 2, 0);

	self.drawIcon:addClickFuntion(self, self.getRewardClick);
end

function Lua_LongMaiActRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local obj = data.goods_info[1];
	self.itemImg.data = Lua_ToolVo.new(tonumber(tostring(obj.id)), obj.value);
	self.desLab.text = data.need_value;

	if data.status == 2 then
		self.itemImg.item_bg.alpha = 0.3;
		self.itemImg.item_img.alpha = 0.3;
	else
		self.itemImg.item_bg.alpha = 1;
		self.itemImg.item_img.alpha = 1;
	end

	self.drawIcon:setEnable(data.status == 1);
	self.redDot:setEnable(data.status == 1);
	self.tipsIcon:setEnable(data.status == 2);
end

function Lua_LongMaiActRewardItem:getRewardClick(go)
	DataCenter.longmaiData:sGetLongmaiPrize(self._data.need_value);
end

function Lua_LongMaiActRewardItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end