checkRequire("Lua_TaskDefine")
Lua_Longmai_MissionItem = class("Lua_Longmai_MissionItem", Lua_ListCell);
function Lua_Longmai_MissionItem:ctor(p)
	self:superCall("ctor", p, "MissionItem_skin");
end
function Lua_Longmai_MissionItem:buildShowItem()
	self:superCall("buildShowItem");

	self:addLuaEvent("UPDATE_MISSION_INFOMATION", self, self.updateMissionInfo)
end

function Lua_Longmai_MissionItem:setData(data)
	self._data = data;
    self:getMissionList()    
end

function Lua_Longmai_MissionItem:getMissionList()
	self.activeTxt.text = tostring(self._data.add_value)

	local num = DataCenter.longmaiData:longMaiConfingInfo(self._data.envent_id, "times_limit");
	if num == 0 then
		self.timesTxt.text = "[85A8BE]"..LanUtil.getValue(121215).."[-]";
		self.nameTxt.text = tostring(self._data.envent_name);
	else
		if self._data.finish_count < self._data.total_count then
			self.timesTxt.text = "[85A8BE]"..tostring(self._data.finish_count).."/"..tostring(self._data.total_count).."[-]"
			self.nameTxt.text = tostring(self._data.envent_name)
		else
			self.timesTxt.text = LanUtil.getValue(121910)
			self.nameTxt.text = tostring(self._data.envent_name)
		end
	end

	local atlas = DataCenter.longmaiData:longMaiConfingInfo(self._data.envent_id, "atlas");
	local iconName = DataCenter.longmaiData:longMaiConfingInfo(self._data.envent_id, "icon_name");
	self.icon:setAltas(atlas, iconName);	
	self.icon:resetSize();
end

function Lua_Longmai_MissionItem:onSelectionChange(val)
    self:superCall("onSelectionChange", val);
    if self.bg ~= nil then
        if val == true then
            self.bg:setAltas("daily_atlas_1", "ui_daily_bg_08");
        else
            self.bg:setAltas("daily_atlas_1", "ui_daily_bg_08");
        end
    end
end

function Lua_Longmai_MissionItem:onPlayerSoundClick()
	local WindowName = DataCenter.longmaiData:longMaiConfingInfo(self._data.envent_id, "corresponding_window")
	local WindowIndex = DataCenter.longmaiData:longMaiConfingInfo(self._data.envent_id, "winIndex")
	local itemId = DataCenter.longmaiData:longMaiConfingInfo(self._data.envent_id, "itemId")

	if WindowName == nil then
		return
	else
		if WindowIndex == -1 then
			Lua_WindowUtil.openWin(WindowName)
		elseif WindowIndex == 0 then
			Lua_WindowUtil.openWin(WindowName, nil,itemId);
		elseif WindowIndex == -2 then
			local tlist = DataCenter.taskData:getListByType(Lua_TaskDefine.ROUTINE);
			if tlist ~= nil and tlist:getSize() > 0 then
     			Lua_WindowUtil.openWin(WindowName, WinParam.ACTION_OPEN, tlist[1]);
			else
				OperateAlert.show(LanUtil.getValue(121919));
				return
			end			
		elseif WindowIndex == -3 then
			Lua_ProxyManager.getProxy("Lua_YunBiaoProxy"):goYunBiao()
		elseif WindowIndex == -4 then
			Lua_MsgUtil.callFunc(WindowName);
		else
			Lua_WindowUtil.openWin(WindowName, WinParam.ACTION_OPEN, WindowIndex);			
		end
		if WindowName ~= "Lua_GamePlayWindow" then
			Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE, nil);
		end
	end
end

function Lua_Longmai_MissionItem:dispose()
	self:superCall("dispose");
end