-- 日常找回
Lua_ResourcePanle = class("Lua_ResourcePanle",Lua_DisplayObject)
function Lua_ResourcePanle:ctor(p)	
	self:superCall("ctor", p, "ResourcePanle_skin");
end

function Lua_ResourcePanle:buildShowItem(go)	
	self:superCall("buildShowItem");

	self.noresource:setEnable(false);

	self.copyList = Lua_DragList.new(self.content,1, Vector4(0, 0, 1132, 526));
	self.copyList:setListCell(Lua_ResourceItem, 120, 566, 2);
	self.copyList:setLocation(-61, 15, 0);

	if DataCenter.saveData:getSaveData(Lua_ServerSaveData.RESOURCE_FOUND) == 1 then
		self.money2.seleted = true;
	else
		self.money1.seleted = true;
	end
	self.money2:addBoxChange(self, self.onmoey2BoxClick);
	self.money1:addBoxChange(self, self.onmoey1BoxClick);

	self.tipsIcon:addClickFuntion(self, self.ontipsClick);
	self.keyBtn:addClickFuntion(self, self.onkeyClick);

	self:addLuaEvent("RESTOREREWARD_UPDATE", self, self.resoureUpdata);
	DataCenter.QiandaoData:getlose();
end

function Lua_ResourcePanle:resoureUpdata()
	self.noresource:setEnable(DataCenter.QiandaoData.isResouce and DataCenter.QiandaoData.islixianResouce);
	if DataCenter.QiandaoData.ResoureData ~= nil then
		local len = DataCenter.QiandaoData.ResoureData:getSize();
		for i = 1, len do
			if self.money2.seleted == true then
				DataCenter.QiandaoData.ResoureData[i].money = DataCenter.QiandaoData.ResoureData[i].gold
				DataCenter.QiandaoData.ResoureData[i].ismoney = true;
				DataCenter.QiandaoData.ResoureData[i].moneytype = 2;
			else
				DataCenter.QiandaoData.ResoureData[i].money = DataCenter.QiandaoData.ResoureData[i].coppermoey
				DataCenter.QiandaoData.ResoureData[i].ismoney = false;
				DataCenter.QiandaoData.ResoureData[i].moneytype = 1;
			end
		end
		self.copyList:setLuaArrayData(DataCenter.QiandaoData.ResoureData,false);
	else
		self.noresource:setEnable(true);
	end
end

function Lua_ResourcePanle:onmoey2BoxClick()
	local config = getConfig({"restore", 100010});
	if config.need_vip == nil then
		config.need_vip = 0;
	end

	if DataCenter.vipData.level >= config.need_vip and DataCenter.roleData.level >= config.need_level then
		self.money2.seleted = true;
		self.money1.seleted = false;
		DataCenter.saveData:setSaveData(Lua_ServerSaveData.RESOURCE_FOUND, 1);
		self:resoureUpdata();
	else
		self.money2.seleted = false;
		self.money1.seleted = true;
		local name = getConfig({"vip_level", config.need_vip, "view_name"});
		if DataCenter.vipData.level < config.need_vip and DataCenter.roleData.level < config.need_level then
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(120866), tostring(config.need_level), name));
		elseif DataCenter.vipData.level < config.need_vip and DataCenter.roleData.level >= config.need_level then
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(120865), name));
		else
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(120864), tostring(config.need_level)));
		end
	end
end

function Lua_ResourcePanle:onmoey1BoxClick()
	self.money2.seleted = false;
	self.money1.seleted = true;
	self:resoureUpdata();
end

function Lua_ResourcePanle:ontipsClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(110924));
end

function Lua_ResourcePanle:onkeyClick()
	if self.money1.seleted then
		if DataCenter.QiandaoData.restorecount == 0 then
			OperateAlert.show(LanUtil.getValue(120959));
			return;
		end
	else
		if DataCenter.QiandaoData.additionalrestorecount == 0 and DataCenter.QiandaoData.restorecount == 0 then
			OperateAlert.show(LanUtil.getValue(120959));
			return;
		end
	end
	Lua_WindowUtil.openWin("Lua_KeyWindow");
end

function Lua_ResourcePanle:dispose()
	if self.copyList ~= nil then
		self.copyList:dispose();
		self.copyList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ResourceItem = class("Lua_ResourceItem", Lua_ListCell);
function Lua_ResourceItem:ctor(p)
	self:superCall("ctor", p, "ResourceItem_skin");
end

function Lua_ResourceItem:buildShowItem()
	self:superCall("buildShowItem");

	self.backIcon:setEnable(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setLayout(80, 70, 5);
	self.rItem:setMaxShow(5);
	self.rItem:setDepth(5);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.75, 0.75);
	self.rItem:setLocation(-220, -14, 0);

	self.backBtn:addClickFuntion(self, self.onbtnClick);
end

function Lua_ResourceItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.desLab.text = data.name;
	self.moneyLab.text = data.money;

	if data.moneytype == 1 then
		self:copperShow();
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(120846), tostring(data.restorecount));

		self.money:setAltas("icon_atlas_3", "money_209000001");
		
		self.backIcon:setEnable(data.restorecount == 0);
		self.moneyLab:setEnable(data.restorecount ~= 0);
		self.money:setEnable(data.restorecount ~= 0);
		self.backBtn:setEnable(data.restorecount ~= 0);
	else
		self:goldShow();
		self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(120847), tostring(data.restorecount), tostring(data.additionalrestorecount));
		
		self.money:setAltas("icon_atlas_3", "money_209000002");

		self.backIcon:setEnable(data.restorecount == 0 and data.additionalrestorecount == 0);
		self.moneyLab:setEnable(data.restorecount ~= 0 or data.additionalrestorecount ~= 0);
		self.money:setEnable(data.restorecount ~= 0 or data.additionalrestorecount ~= 0);
		self.backBtn:setEnable(data.restorecount ~= 0 or data.additionalrestorecount ~= 0);
	end
end

function Lua_ResourceItem:copperShow()
	local copperlen;
	if self._data.ordinaryexp == 0 then
		copperlen = #self._data.copper_rewards;
	else
		copperlen = #self._data.copper_rewards + 1;
	end

	local tvo;
	local rewardArr = Array();
	for i = 1, copperlen do
		if i > #self._data.copper_rewards then   
			tvo = Lua_ToolVo.createToolVo(self._data.copperexp[1], self._data.ordinaryexp);
		else
			tvo = Lua_ToolVo.createToolVo(self._data.copper_rewards[i][1], self._data.copper_rewards[i][2], self._data.copper_rewards[i][3]);
		end

		if self._data.id == 100060 then
			tvo  = Lua_ToolVo.createToolVo(201030028);
		end
		rewardArr:add(tvo);
	end
	self.rItem:setRewardByArray(rewardArr);
end

function Lua_ResourceItem:goldShow()
	local goldlen;
	if self._data.additionalexp == 0 then
		goldlen = #self._data.gold_rewards;
	else
		goldlen = #self._data.gold_rewards + 1;
	end

	local tvo;
	local rewardArr = Array();
	for i = 1, goldlen do
		if i > #self._data.gold_rewards then
			tvo = Lua_ToolVo.createToolVo(self._data.goldexp[1], self._data.additionalexp);
		else
			tvo = Lua_ToolVo.createToolVo(self._data.gold_rewards[i][1], self._data.gold_rewards[i][2], self._data.gold_rewards[i][3]);
		end

		if self._data.id == 100060 then
			tvo = Lua_ToolVo.createToolVo(201030028);
		end
		rewardArr:add(tvo);
	end
	self.rItem:setRewardByArray(rewardArr);
end

function Lua_ResourceItem:onbtnClick()
	if self._data.id == nil  then
		DataCenter.QiandaoData:getoffline(self._data.moneytype);
	else
		local vo = Lua_ResourceVo.new(self._data.id);
		if self._data.restorecount > 0 then
			Lua_WindowUtil.openWin("Lua_ResourceTipsWindow", WinParam.ACTION_OPEN, {id = self._data.id, resouretype = 1,
				moneytype = self._data.moneytype, money = self._data.money,
				additionalrestorecount = self._data.restorecount, additionalneedgold = vo.additionalgold});
		else
			Lua_WindowUtil.openWin("Lua_ResourceTipsWindow", WinParam.ACTION_OPEN, {id = self._data.id, resouretype = 2,
				moneytype = 2, money = self._data.gold,
				additionalrestorecount = self._data.additionalrestorecount, additionalneedgold = vo.additionalgold});
		end
	end
end

function Lua_ResourceItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end