-- 水晶之战左侧栏信息面板
Lua_CrystalWarLeftInfoPanel = class("Lua_CrystalWarLeftInfoPanel", Lua_DisplayObject);
function Lua_CrystalWarLeftInfoPanel:ctor(p)
	self:superCall("ctor", p, "CrystalWarLeftInfoPanel_skin");
end

function Lua_CrystalWarLeftInfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self._showState = true;

	self.shuijing1:addClickFuntion(self, self.moveToTarget);
	self.shuijing2:addClickFuntion(self, self.moveToTarget);
	self.shuijing3:addClickFuntion(self, self.moveToTarget);
	self.shuijing4:addClickFuntion(self, self.moveToTarget);
	self.buffList = {[1] = self.shuijing1, [2] = self.shuijing2, [3] = self.shuijing3, [4] = self.shuijing4};

	self.titleBg.clickScale = false;
	self.bg.clickScale = false;
	self.titleBg:addClickFuntion(self, self.onBgClick);
	self.bg:addClickFuntion(self, self.onBgClick);
	self.closeBtn:addClickFuntion(self, self.onArrowBtnClick);
	self.rankBtn:addClickFuntion(self, self.onRankBtnClick);
	self.wenhao:addClickFuntion(self, self.onHelp);
end

function Lua_CrystalWarLeftInfoPanel:moveToTarget(go)
	if GlobalVar.hooking == true then
		DataCenter.hook:stop(true);
	end
	local posArr = DataCenter.crystalWarData.buff_pos
	local index = tonumber(string.sub(go.name, -1, -1));
	local pos = posArr[index];
	WorldMapUtil.moveTo(DataCenter.roleData.sceneId, pos[1], pos[2], pos[3], pos[4], 3, nil, 0);
end

function Lua_CrystalWarLeftInfoPanel:onBgClick(go)
end

function Lua_CrystalWarLeftInfoPanel:onArrowBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	self:setShowState(not self._showState);
end

function Lua_CrystalWarLeftInfoPanel:onRankBtnClick(go)
	Lua_WindowUtil.openWin("Lua_CrystalWarRankWindow", WinParam.ACTION_OPEN);
end

function Lua_CrystalWarLeftInfoPanel:onHelp()
    Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(128116));
end

function Lua_CrystalWarLeftInfoPanel:setShowState(val)
	self._showState = val;
	if val then
		self.closeIcon:setSacle(0.8, 0.8);
		self.closeBtn:setLocation(-386.5, 135, 0);
		self.closeIcon:setLocation(-388, 139, 0);
		self.rankBtn:setLocation(-345, 137, 0);
		TweenUtil.getInstance():addTween(self.content, 0.5, 0, Vector3(0, -2, 0), nil, nil);
	else
		self.closeBtn:setLocation(-386.5 + self.closeBtn.width + 13, 135, 0);
		self.closeIcon:setLocation(-388 - 1.5 + self.closeBtn.width + 13, 139, 0);
		self.closeIcon:setSacle(-0.8, 0.8);
		self.rankBtn:setLocation(-395, 137, 0);
		TweenUtil.getInstance():addTween(self.content, 0.5, 0, Vector3(-269, -2, 0), nil, nil);
	end
end

-- 更新信息
function Lua_CrystalWarLeftInfoPanel:updateCrystalWarInfo()
	local buffNum = DataCenter.crystalWarData.buffNum;
	self.campName.text = LanUtil.formateStr(LanUtil.getValue(128110), tostring(DataCenter.crystalWarData.myCampName));
	self.rankTxt.text = LanUtil.formateStr(LanUtil.getValue(128111), tostring(DataCenter.crystalWarData.rank));
	self.jifenTxt.text = LanUtil.formateStr(LanUtil.getValue(128112), tostring(DataCenter.crystalWarData.self_score));
	self.bossTxt.text = LanUtil.formateStr(LanUtil.getValue(128113), tostring(DataCenter.crystalWarData.camp_value), tostring(DataCenter.crystalWarData.bossScore));
	self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(128114), tostring(buffNum));

	local buffList = DataCenter.crystalWarData.buffStateList
	local buffListLen = #buffList
	for i = 1, buffListLen do
		self.buffList[buffList[i].index]:setGray(not buffList[i].state)
	end

	local num = DataCenter.crystalWarData.fightCountDown;
	if num > 0 then
		self:clearTimer();
		num = DataCenter.crystalWarData.fightResidueTime - num;
	else
		num = DataCenter.crystalWarData.fightResidueTime;
	end
	self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(128115), TimeTransform.getInstance():transSeconds1(num, true));
end

-- 开始计时
function Lua_CrystalWarLeftInfoPanel:startCrystalWarFightTime()
    local num = DataCenter.crystalWarData.fightResidueTime;
    if num > 0 then
        if self.bRegisterTimer == nil or self.bRegisterTimer == false then
            self.bRegisterTimer = true;
            Lua_CommonUtil.addTimer("updateOwnCampWarInfoTime", 1, self, self.updateOwnCampWarInfoTime, nil, -1);
        end
    end
    self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(128115), TimeTransform.getInstance():transSeconds1(num, true));
end

function Lua_CrystalWarLeftInfoPanel:updateOwnCampWarInfoTime()
    local num = DataCenter.crystalWarData.fightResidueTime;
    if num <= 0 then
        num = 0;
        self:clearTimer();
    end
    self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(128115), TimeTransform.getInstance():transSeconds1(num, true));
end

function Lua_CrystalWarLeftInfoPanel:clearTimer()
    if self.bRegisterTimer ~= nil and self.bRegisterTimer == true then
        self.bRegisterTimer = false;
        Lua_CommonUtil.removeTimer(self, self.updateOwnCampWarInfoTime);
    end
end

function Lua_CrystalWarLeftInfoPanel:dispose()
    self:clearTimer();
    TweenUtil.getInstance():stop(self.content);

    self:superCall("dispose");
end