-- 水晶之战战斗场景
checkRequire("Lua_CrystalWarLeftInfoPanel");
checkRequire("Lua_CrystalWarInfoPanel");
Lua_CrystalWarMainWindow = class("Lua_CrystalWarMainWindow", Lua_FullSizeWindow);
function Lua_CrystalWarMainWindow:ctor()
    self:superCall("ctor", false, false, 500, false, false, false);
    self.windowName = "Lua_CrystalWarMainWindow";
end

function Lua_CrystalWarMainWindow:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.hook:stop(true);
	Lua_MsgUtil.callFunc("SETSKILLMENUSTATE", 2);

	self.blackBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 1280, 720);
	self.blackBg.name = "blackBg";
	self.blackBg.alpha = 0.5;
	self.blackBg:setDepth(20);
	self.blackBg:setEnable(true);

	self.leftInfoPanel = Lua_CrystalWarLeftInfoPanel.new(self.content);
	self.leftInfoPanel:setLocation(-MainWinDefine.V_width / 2 + 640, 0);

	self.fightInfoPanel = Lua_CrystalWarInfoPanel.new(self.content);

	self.blackBg:addClickFuntion(self, self.onBlackBgClick);

	self:addLuaEvent("UPDATA_CRYSTAL_PANEL", self, self.onUpdateInfo);
	self:addLuaEvent("MENU_OUT_CLICK", self, self.onExitCampWarScene);
	sendMsg(10400862);
end

function Lua_CrystalWarMainWindow:onBlackBgClick(go)
end

-- 战斗信息
function Lua_CrystalWarMainWindow:onUpdateInfo()
    self.leftInfoPanel:updateCrystalWarInfo();
    self.fightInfoPanel:updateCrystalWarFightInfo();

    local num = DataCenter.crystalWarData.fightCountDown;
    if num > 0 then
        if GlobalVar.hooking == true then
            DataCenter.hook:stop(true);
        end

        if self.countDownAni == nil then
            self.countDownAni = Lua_CountDownAnimation.new(self.content, self, self.countDownComplete);
            self.countDownAni:setDepth(10);
        end
        self.countDownAni:playCountDown(num, 1);
    else
        self:countDownComplete();
    end
end

function Lua_CrystalWarMainWindow:countDownComplete()
	self.leftInfoPanel:startCrystalWarFightTime();
	if self.countDownAni ~= nil then
		self.countDownAni:dispose();
		self.countDownAni = nil;
	end
	self.blackBg:setEnable(false);
end

function Lua_CrystalWarMainWindow:onExitCampWarScene()
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122719), type = 1, subFun = self.onOutClick});
end

function Lua_CrystalWarMainWindow:onOutClick()
	Lua_ProxyManager.getProxy("Lua_CrystalWarProxy"):sExitScene();
end

function Lua_CrystalWarMainWindow:dispose()
	if self.leftInfoPanel ~= nil then
		self.leftInfoPanel:dispose();
		self.leftInfoPanel = nil;
	end
	if self.fightInfoPanel ~= nil then
		self.fightInfoPanel:dispose();
		self.fightInfoPanel = nil;
	end
	if self.countDownAni ~= nil then
		self.countDownAni:dispose();
		self.countDownAni = nil;
	end
	self:superCall("dispose");
end