-- 水晶之战排行榜
Lua_CrystalWarRankWindow = class("Lua_CrystalWarRankWindow", Lua_ThirdSizeWindow)
function Lua_CrystalWarRankWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(122704));

	self.windowName = "Lua_CrystalWarRankWindow";
	self.skinName = "CrystalWarRankWindow_skin";
	self.w = 916;
	self.h = 574;
end

function Lua_CrystalWarRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rankList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 878, 360));
	self.rankList:setLocation(0, -24, 0);
	self.rankList:setListCell(Lua_CystalWarRankItem, 72, 878, 1);

	self:addLuaEvent("UPDATA_CRYSTAL_RANK", self, self.onCampWarRankInfo)
	Lua_ProxyManager.getProxy("Lua_CrystalWarProxy"):sInitRankMsg();
end

function Lua_CrystalWarRankWindow:onCampWarRankInfo(msg)
	if msg == nil then
		return;
	end

	if msg.rank == nil then
		return;
	end

	local owner;
	local arr = Array();
	for i = 1, #msg.rank do
		if owner == nil and tostring(DataCenter.roleData.roleId) == tostring(msg.rank[i].role_id) then
			owner = msg.rank[i];
		end
		arr:add(msg.rank[i]);
	end
	self.rankList:setLuaArrayData(arr, false);

	if owner ~= nil then
		if owner.rank > 3 then
			self.myRankIcon:setEnable(false);
			self.myRankTxt.text = owner.rank;
		elseif owner.rank <= 0 then
			self.myRankIcon:setEnable(false);
			self.myRankTxt.text = "--";
		else
			self.myRankIcon:setEnable(true);
			self.myRankIcon:setAltas("leaderBoard_atlas", DataCenter.answerUtil.rankBeforeThreeUrl[owner.rank]);
			self.myRankTxt.text = "";
		end

		self.myNameTxt.text = DataCenter.roleData.name;
		self.myLvTxt.text = DataCenter.roleData.level;
		self.myCampName.text = DataCenter.campWarUtil:getCampNameById(owner.camp_id);
		self.myKillNum.text = owner.kill;
		self.myJifenTxt.text = owner.score;
		self.myserverName.text = DataCenter.roleData.server_name
	else
		self.myRankIcon:setEnable(false);
		self.myRankTxt.text = "--";
		self.myNameTxt.text = DataCenter.roleData.name;
		self.myLvTxt.text = DataCenter.roleData.level;
		self.myCampName.text = DataCenter.crystalWarData:getCampNameById(DataCenter.crystalWarData.self_camp);
		self.myKillNum.text = "0";
		self.myJifenTxt.text = "0";
		self.myserverName.text = DataCenter.roleData.server_name
	end
end

function Lua_CrystalWarRankWindow:dispose()
	if self.rankList ~= nil then
		self.rankList:dispose()
		self.rankList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_CystalWarRankItem = class("Lua_CystalWarRankItem", Lua_ListCell);
function Lua_CystalWarRankItem:ctor(p)
	self:superCall("ctor", p, "CystalWarRankItem_skin");
end

function Lua_CystalWarRankItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CystalWarRankItem:setData(data)
	self.data = data;

	if data.rank > 3 then
		self.rankIcon:setEnable(false);
		self.rankTxt.text = data.rank;
	elseif data.rank <= 0 then
		self.rankIcon:setEnable(false);
		self.rankTxt.text = "--";
	else
		self.rankIcon:setEnable(true);
		self.rankIcon:setAltas("leaderBoard_atlas", DataCenter.answerUtil.rankBeforeThreeUrl[data.rank]);
		self.rankTxt.text = "";
	end

	self.nameTxt.text = "[85A8BE]" .. data.role_name .. "[-]";
	self.lvTxt.text = "[85A8BE]" .. data.level .. "[-]";
	self.campName.text = "[85A8BE]" .. DataCenter.crystalWarData:getCampNameById(data.camp_id) .. "[-]";
	self.killNum.text = "[85A8BE]" .. data.kill .. "[-]";
	self.jifenTxt.text = "[85A8BE]" .. data.score .. "[-]";
	self.serverName.text = "[85A8BE]" .. data.server_name .. "[-]";

	self.enemyBg:setEnable(data.camp_id ~= DataCenter.crystalWarData.self_camp);
	self.friendBg:setEnable(data.camp_id == DataCenter.crystalWarData.self_camp);
end

function Lua_CystalWarRankItem:dispose()
	self:superCall("dispose");
end