﻿checkRequire("Lua_GiftItem");
Lua_GiftDropOutWindow = class("Lua_GiftDropOutWindow", Lua_FullSizeWindow);
function Lua_GiftDropOutWindow:ctor()
	self:superCall("ctor", false, false, 2500, false, false, false);
	self.windowName = "Lua_GiftDropOutWindow";
end

function Lua_GiftDropOutWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.boxArr = Array();
	self:onUpadateGiftInfo();

	self:addLuaEvent("GIFT_DESTROY_XIANSHI", self, self.onDestroyBoxEvent);
end

function Lua_GiftDropOutWindow:onUpadateGiftInfo()
	self.giftIDX = 0;
	self.isCreate = true;
	self.giftArr = DataCenter.giftData.IndexArr;

	self.giftCount = DataCenter.giftData.IndexArr:getSize();
	if self.giftCount ~= 0 then
		Lua_CommonUtil.addTimer("onDropOutKey", 1, self, self.onBegainDropOut);
	end
end

function Lua_GiftDropOutWindow:onBegainDropOut()
	self.giftIDX = self.giftIDX + 1;
	if self.giftIDX <= self.giftCount and self.giftCount ~= 0 then
		self.isCreate = true;
	else
		self.isCreate = false;
		Lua_CommonUtil.removeTimer(self, self.onBegainDropOut);
	end

	if self.isCreate == true then
		local boxIcon = Lua_GiftItem.new(self.content);
		boxIcon:setData(DataCenter.giftData.Rewards[self.giftArr[self.giftIDX]]);
		self.boxArr:add(boxIcon);
	end
end

function Lua_GiftDropOutWindow:onDestroyBoxEvent(index)
	for i = 1, self.boxArr:getSize() do
		if self.boxArr[i] ~= nil and self.boxArr[i].index == index and self.boxArr[i].isOpen == false then
			self.boxArr[i].isOpen = true;
			self.boxArr[i]:showEffect();
			return;
		end
	end
end 

function Lua_GiftDropOutWindow:dispose()
	if self.boxArr ~= nil then
		self.boxArr:dispose()
		self.boxArr:clear();
		self.boxArr = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onBegainDropOut);

	self:superCall("dispose");
end