﻿Lua_RewardGainWindow = class("Lua_RewardGainWindow", Lua_TreasureResultWindow);
function Lua_RewardGainWindow:ctor()
    self:superCall("ctor");
    self.layer = 3600;
    self.needItemName = true;
    self.windowName = "Lua_RewardGainWindow";
end

function Lua_RewardGainWindow:buildPanel(go)
    self:superCall("buildPanel", go);
    self:setAgainBtnState(false);
    self:setSubBtnPos(-16, -285);
    self:addLuaEvent("rTreasureRunesDraw", self, self.onTreasureRunesDraw);
end

function Lua_RewardGainWindow:showWin(param)
    self.arr = param;
    --  self:showRewards();
    if self.arr:getSize() <= 10 then
        self:setShowResultData(self.arr, nil);
    else
        self:showRewards();
    end
    local specialItemArr = DataCenter.giftPlayData.specialItemArr
    local len = specialItemArr:getSize()
    for i = 1, len do
        local itemImg = Lua_ToolImage.new(self.content);
        itemImg:setDepth(5);
        itemImg:setCanClick(true);
        itemImg:setScale(0.5, 0.5)
        itemImg.data = specialItemArr[i]
        itemImg:showNewTip(false);
        itemImg:showItemBg(false)
        itemImg:showNum(0, false)
        local label = UICreate.createLabel(self.content, "", -115, -195, 227, 30, 24);
        label.overflowMethod = UILabel.Overflow.ResizeFreely;
        label.pivot = UIWidget.Pivot.Left;
        label:setDepth(5);
        label.text = LanUtil.formateStr(LanUtil.getValue(123808), tostring(itemImg.data.colorName))
        label:setLocation(-115, -195 -(i - 1) * 40, 0);
        local offset = 0
        offset = label.mainContent.transform.localPosition.x + label.width + 15
        itemImg:setLocation(offset + 10, -195 -(i - 1) * 40, 0);
        label.text = label.text

        local label2 = UICreate.createLabel(self.content, "", -80, -195, 227, 30, 24);
        label2.pivot = UIWidget.Pivot.Left;
        label2.overflowMethod = UILabel.Overflow.ResizeFreely;
        label2:setDepth(5);
        label2.text = itemImg.data.count
        label2:setLocation(offset + 35, -195 -(i - 1) * 40, 0);
    end
end
function Lua_RewardGainWindow:showRewards()
    self.reward_DragList = Lua_DragList.new(self.content, 1, Vector4(0, -4, 850, 288));
    self.reward_DragList:setLocation(8, -20, 0);
    self.reward_DragList:setListCell(Lua_GiftRewardItemTips, 143, 160, 5);
    self.reward_DragList.canDrag = true;
    self.reward_DragList:setLuaArrayData(self.arr, true);
end
function Lua_RewardGainWindow:onTreasureRunesDraw()
end
function Lua_RewardGainWindow:dispose()
    if self.reward_DragList ~= nil then
        self.reward_DragList:dispose();
    end
    self:superCall("dispose");
end

Lua_GiftRewardItemTips = class("Lua_GiftRewardItemTips", Lua_ListCell);
function Lua_GiftRewardItemTips:ctor(p)
    self:superCall("ctor", p);
end
function Lua_GiftRewardItemTips:buildShowItem()
    self:superCall("buildShowItem");
    self.itemImg = Lua_ToolImage.new(self.content);
    self.itemImg:setDepth(5);
    self.itemImg:setLocation(0, 3, 0);
    self.itemImg:setCanClick(false);

    self.itemName = UICreate.createLabel(self.content, "", 0, -65, 155, 30, 24);
    self.itemName:setDepth(6);
    self.itemName.pivot = UIWidget.Pivot.Center;
end

function Lua_GiftRewardItemTips:setData(data)
    self._data = data;
    self.itemImg.data = data;
    self.itemImg:showNewTip(false);
    self.itemName.text = self.itemImg.data.colorName
end
function Lua_GiftRewardItemTips:onPlayerSoundClick()
    Lua_PackUtil.showItemInfo(self._data, nil, nil, false);
end

function Lua_GiftRewardItemTips:checkOutBound(showRect)
    if self._data == nil then
        self.inViewEffect = false;
        return;
    end

    local rect = Lua_Rectangle.new(self.itemX - 50, self.itemY - 10, 100, 60);
    if showRect:containeRect(rect) == true then
        self.inViewEffect = true;
    else
        self.inViewEffect = false;
    end

    self:updateEffectState();
end

function Lua_GiftRewardItemTips:updateEffectState()
    if self.inViewEffect == true then
        if self.itemImg.qualityEff == nil then
            self.itemImg:showQualityEff(true);
        end
    else
        if self.itemImg.qualityEff ~= nil then
            self.itemImg:showQualityEff(false);
        end
    end
end

function Lua_GiftRewardItemTips:dispose()
    self:superCall("dispose");
end