Lua_XianShiOneItem = class("Lua_XianShiOneItem", Lua_ListCell);
function Lua_XianShiOneItem:ctor(p)
	self:superCall("ctor",p, "XianShiOneItem_skin");
end

function Lua_XianShiOneItem:checkOutBound(showRect)
	if self._data == nil or self._data.activity_state ~= 2 then
		self.inViewEffect = false;
		return;
	end
	local rect = Lua_Rectangle.new(self.itemX + 143, self.itemY - 24, 100,50);
	if showRect:containeRect(rect) == true then
		self.inViewEffect = true;
	else
		self.inViewEffect = false;
	end
	self:updateEffectState();
end

function Lua_XianShiOneItem:updateEffectState()
	if self.inViewEffect == true and self.actShowEffect == true then
		if self.effect == nil then
			self.effect = UICreate.createUIEffect(self.content,nil ,nil, 193.5, -2);
			self.effect:setUrl("/effects/scsEffects/anniutexiao","anniutexiao");
			self.effect:setSacle(0.74,0.79,1);
			self.effect:setLocation(193.5,-2)
			self.effect:SetRenderQueue(self.bg, 5, 2,false);
		end
		self.effect:setEnable(true);
	else
		if self.effect ~= nil then
			self.effect:setEnable(false);
		end
	end
end

function Lua_XianShiOneItem:setData(data)
	self._data = data;
	self.actShowEffect = false;

	self.content.name = "c_"..data.id;
	self.nameTxt.text = data.name;
	self:showRedDot(false);
	if self.copyIcon == nil then
		self.copyIcon = UICreate.createUIAtlasImage(self.content, data.atlas, data.icon, 0, 0, 0, 0);
	end
	self.copyIcon:setAltas(data.atlas, data.icon);
	-- self.copyIcon:resetSize();
	self.copyIcon:setDepth(4);
	self.copyIcon:setLocation(-216,0,0);

	if data.activity_state ~= nil then
		self.timeTxt.text = "[85A8BE]"..data.pShowTime.."[-]";

		self.lockSp:setEnable(false);
		self.circleBg2:setEnable(false);

		self.stateBg:setEnable(true);
		self.stateTxt.uiwidget.gameObject:SetActive(true);
		self.goBtn:setBtnEnable(true);
	else
		if data.dic == nil then
			self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121102), tostring(data.limit_level));
		else
			if DataCenter.funcOpenData.isPanGuNew == 0 then
				self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121102), tostring(data.limit_level));
			else
				if DataCenter.funcOpenData.panguShow == 2 then
					self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121102), tostring(data.limit_level));
				else
					self.timeTxt.text = data.dic;
				end
			end
		end

		self.lockSp:setEnable(true);
		self.circleBg2:setEnable(true);

		self.stateBg:setEnable(false);
		self.stateTxt.uiwidget.gameObject:SetActive(false);
		self.goBtn:setBtnEnable(false);
	end

	if 	self._data.bOpenToday == true then
		if self._data.activity_state == nil or self._data.activity_state == 0 or self._data.activity_state == 1 then
			self.stateTxt.text = LanUtil.getValue(121128);
			self.stateBg:setAltas("common_atlas_2", "ui_common_bq_004");
		elseif self._data.activity_state == 2 then
			self.actShowEffect = true;
			self.stateTxt.text = LanUtil.getValue(121129);
			self.stateBg:setAltas("common_atlas_2", "ui_common_bq_005");
		elseif self._data.activity_state == 3 then
			self.stateTxt.text = LanUtil.getValue(121130);
			self.stateBg:setAltas("common_atlas_1", "ui_common_bq_002");
		end
	else
		self.stateTxt.uiwidget.gameObject:SetActive(false)
		self.stateBg:setEnable(false);
	end

	self.remarkTxt.text = data.remark;
	if data.remark ~= nil and data.remark ~= "" then
		self.nameTxt:setLocation(-142, 35);
		self.remarkTxt:setLocation(-160, -3);
		self.timeTxt:setLocation(-160, -20);
	else
		self.nameTxt:setLocation(-142, 15);
		self.timeTxt:setLocation(-160, -10);
	end

	if self._data.redDot == 10013 and DataCenter.redDotData:getRedDotStateByEventId(10510) == true then -- 天选之战红点
		self:showRedDot(true);
	end

	if self._data.activity_state == 2 and self._data.id == DataCenter.poolPartyData.activity_id and DataCenter.redDotData:getRedDotStateByEventId(22055) == true then
		self:showRedDot(true);
	end

	self:updateEffectState();
	self.goBtn:addClickFuntion(self,self.onGotoClick);
end

function Lua_XianShiOneItem:onGotoClick(go)
	-- local sceneId = getConfig({"convoy_const", "scene", "value"});
	-- local npc =  DataCenter.yunBiaoData:getNpcInfo(0);
	if self._data.fun_str ~= nil then
		if self._data.attend ~= nil and self._data.attend == 1 then
			OperateAlert.show(LanUtil.getValue(122721));
			return;
		end

		if self._data.fun_str == "Lua_YunBiaoWindow" then 
			-- if DataCenter.roleData.sceneId ~= sceneId then
			-- 	local pos = getConfig({"scene", sceneId, "fixed_pos"});
			-- 	Lua_ProxyManager.getProxy("Lua_MapProxy"):sTransfer(sceneId, pos[1], pos[2], pos[3], 0);
			-- 	self:addCSharpEvent("INIT_SCENE_CONFIG_OBJECT", self, self.onSceneLoaded);
			-- else
			-- 	WorldMapUtil.moveTo(npc.sceneId, npc.pos[1], npc.pos[2], npc.pos[3], npc.npcId, 7, nil, 0);
			-- 	Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE);
			-- end
			Lua_ProxyManager.getProxy("Lua_YunBiaoProxy"):goYunBiao();
			Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE);	
		else
			if self._data.fun_str == "Lua_PoolPartyWindow" then 
				DataCenter.redDotData:updateRedDotVoState(22055, false);
				Lua_MsgUtil.callFunc("UPDARE_POOL_RED_EVENT");
			end

			Lua_WindowUtil.openWin(self._data.fun_str);
		end	
	end
end

function Lua_XianShiOneItem:onSceneLoaded()
	local npc =  DataCenter.yunBiaoData:getNpcInfo(0);
	WorldMapUtil.moveTo(npc.sceneId, npc.pos[1], npc.pos[2], npc.pos[3], npc.npcId, 7, nil, 0);
	Lua_WindowUtil.openWin("Lua_GamePlayWindow", WinParam.ACTION_CLOSE);
end

function Lua_XianShiOneItem:showRedDot(val)--红点显示
    if val == true then
        if self._redDotIcon == nil then
            self._redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian",261,22, 0, 0);
            self._redDotIcon:setDepth(25);
            self._redDotIcon.name = "redDotIcon1";
        end
        self._redDotIcon:setEnable(true);
    else
        if self._redDotIcon ~= nil then
            self._redDotIcon:setEnable(false);
        end
    end
end


function Lua_XianShiOneItem:dispose()
	self:superCall("dispose");
	if self.effect ~= nil then
		self.effect:dispose();
		self.effect = nil;
	end
end